#include <iostream>
#include <stdio.h>
#include "app/Application.h"   // Be's BApplication class, necessary for any GUI stuff
#include "interface/Window.h"  // Be's BWindow class
#include <View.h>
#include "ColorButton.h"
const uint32 COLOURPREFS_TEST = 'cpts';
//custom BWindow subclass
class BrentWindow : public BWindow
{
	public:
		BrentWindow();
		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage* msg);
	private:
		BView* parent;
		ColorButton* cb;
		
};
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,450,450), "Brent's Window!", B_TITLED_WINDOW, 0)
{
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL_SIDES,B_WILL_DRAW);
	parent->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	AddChild(parent);
	
	rgb_color c = {0,51,255};
	cb = new ColorButton(BRect(20,20,120,34),new BMessage(COLOURPREFS_TEST),c,"TESTING");
	cb->SetViewColor(parent->ViewColor());
	parent->AddChild(cb);
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
void BrentWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{	
		case COLOURPREFS_TEST:
		{
			//cout << "test" << endl;
			rgb_color c = cb->Value();
			//cout << (int)c.red << " " << (int)c.green << " " << (int)c.blue << endl;
		}break;
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}

int main(int argc, char ** argv)
{
	BApplication app("application/x-vnd.Brent-template");//gotta have this
	//Create the window..
	BWindow* window = new BrentWindow();
	window->Show();	//shows up the window
	app.Run();
	return 0;
}
