#include "CharRenderer.h"
CharRenderer::CharRenderer()
{
	error = FT_Init_FreeType(&lib);
	color.red=color.green=color.blue=0;
	color.alpha=255;
	//SetSize(20);
	size=12;
	theta = 0;
}
void CharRenderer::SetSize(int s)
{
	size = s;
	error = FT_Set_Char_Size (face, 0, size*64, 0, 0);
}
void CharRenderer::SetPath(const char* p)
{
	path.SetTo(p);
	if(path.InitCheck()==B_OK)
		error = FT_New_Face (lib,path.Path(), 0, &face);
	
}
void CharRenderer::SetColor(rgb_color c)
{
	color = c;
}
void CharRenderer::SetAngle(float angle)
{
	theta = angle*PI/180;
}
BBitmap* CharRenderer::Render(int idx)
{
	SetSize(size);
	
	FT_Glyph glyph;
	FT_BitmapGlyph bitmap;

	FT_Matrix matrix;
 	matrix.xx = (FT_Fixed)( cos( theta ) * 0x10000L );
  	matrix.xy = (FT_Fixed)(-sin( theta ) * 0x10000L );
   	matrix.yx = (FT_Fixed)( sin( theta ) * 0x10000L ); 
   	matrix.yy = (FT_Fixed)( cos( theta ) * 0x10000L ); 	
	FT_Set_Transform( face, &matrix, NULL );
	
	FT_Load_Glyph (face, idx, FT_LOAD_DEFAULT);
	FT_Get_Glyph (face->glyph, &glyph);
	if (glyph->format != FT_GLYPH_FORMAT_BITMAP)
		error = FT_Glyph_To_Bitmap(&glyph, FT_RENDER_MODE_NORMAL, 0, 1);
	bitmap = reinterpret_cast<FT_BitmapGlyph>(glyph);
	
	height=bitmap->bitmap.rows;
	width=bitmap->bitmap.width;
	pitch=bitmap->bitmap.pitch;
	
	//Michael Pfeiffer (of BePDF fame) is a Bloody Legend for
	//Coming up with this!
	BBitmap* final = new BBitmap(BRect(0,0,width-1,height-1),B_RGBA32);
	unsigned char* bbitmap_destination = (unsigned char*)final->Bits();
	int bpr=final->BytesPerRow();
	
	unsigned char* bitmap_source = (unsigned char *)bitmap->bitmap.buffer;
	alpha = color.alpha;
	for(int y=0;y < height;y++)
	{
		color_ptr = (rgb_color*)bbitmap_destination;
		unsigned char* temp_source = bitmap_source;
		for(int x=0;x < width;x++,temp_source++,color_ptr++)
		{
			color.alpha = (*temp_source)*alpha/255;
			*color_ptr = color;
		}
		bitmap_source += pitch;
		bbitmap_destination += bpr;
	}
	//the color is altered so we need to reset it
	color.red=color.green=color.blue=0;
	color.alpha=255;
	
	FT_Done_Glyph (glyph);
	
	return final;
}
/*BBitmap* CharRenderer::RenderColored(int idx,rgb_color c)
{
	SetSize(size);
	
	FT_Glyph glyph;
	FT_BitmapGlyph bitmap;
	
	FT_Load_Glyph (face, idx, FT_LOAD_DEFAULT);
	FT_Get_Glyph (face->glyph, &glyph);
	if (glyph->format != FT_GLYPH_FORMAT_BITMAP)
		error = FT_Glyph_To_Bitmap(&glyph, FT_RENDER_MODE_NORMAL, 0, 1);
	bitmap = reinterpret_cast<FT_BitmapGlyph>(glyph);
	
	height=bitmap->bitmap.rows;
	width=bitmap->bitmap.width;
	pitch=bitmap->bitmap.pitch;
	
	//Michael Pfeiffer (of BePDF fame) is a Bloody Legend for
	//Coming up with this!
	BBitmap* final = new BBitmap(BRect(0,0,width-1,height-1),B_RGBA32);
	unsigned char* bbitmap_destination = (unsigned char*)final->Bits();
	int bpr=final->BytesPerRow();
	
	unsigned char* bitmap_source = (unsigned char *)bitmap->bitmap.buffer;
	alpha = c.alpha;
	for(int y=0;y < height;y++)
	{
		color_ptr = (rgb_color*)bbitmap_destination;
		unsigned char* temp_source = bitmap_source;
		for(int x=0;x < width;x++,temp_source++,color_ptr++)
		{
			c.alpha = (*temp_source)*alpha/255;
			*color_ptr = c;
		}
		bitmap_source += pitch;
		bbitmap_destination += bpr;
	}
	//the color is altered so we need to reset it
	//SetColor(c);
	
	FT_Done_Glyph (glyph);
	
	return final;
}
	*/