#include "BrentWindow.h"

#include <string>
#include <cmath>
#include <Point.h>

float min(float f1,float f2)
{
	return f1 <= f2 ? f1 : f2;
}
float max(float f1,float f2)
{
	return f1 >= f2 ? f1 : f2;
}

// not sure where you want to put this... but it has to be inside a function, and not the inner copy loop
void
put_pixel (uint8 *dst, uint8 *src, int32 dstX, int32 dstY, int32 srcX, int32 srcY, 
			int32 dst_rowbytes, int32 src_rowbytes, int32 pixel_width) 
{
	dst += (dst_rowbytes * dstY) + (dstX * pixel_width);
	src += (src_rowbytes * srcY) + (srcX * pixel_width);
	memcpy (dst, src, pixel_width);
}
void RotatePoint(BPoint& p,float theta)
{
	float radians = PI*theta/180;
	float cosine = (float)cos(radians);
	float sine = (float)sin(radians);	
	float x = p.x;
	float y = p.y;
	
	p.x = x*cosine + y*sine;
	p.y = x*sine + y*cosine;
}
BBitmap* Rotate(BBitmap* source,float theta)
{
		//typedef unsigned char ftype;
		//struct four { ftype a;ftype b;ftype c;ftype d;};
		
		float radians = PI*theta/180;
		float cosine = (float)cos(radians);
		float sine = (float)sin(radians);
		
		BRect r = source->Bounds();
		//r.OffsetBy(0,-r.Height());
		BPoint lt(r.LeftTop());
		BPoint rt(r.RightTop());
		BPoint lb(r.LeftBottom());
		BPoint rb(r.RightBottom());
		cout << "Before Rotation" << endl;
		lt.PrintToStream();
		rt.PrintToStream();
		lb.PrintToStream();
		rb.PrintToStream();
		theta = 45;
		RotatePoint(lt,theta);
		RotatePoint(rt,theta);
		RotatePoint(lb,theta);
		RotatePoint(rb,theta);
		cout << "After Rotation" << endl;
		lt.PrintToStream();
		rt.PrintToStream();
		lb.PrintToStream();
		rb.PrintToStream();
		
		
		/*
		color_space cs;
		int32 w, h, pixel_width = 4;  // sorry I had to hardcode that!
		BBitmap *bmp;
		ftype *dst, *src;
		int32 src_rowbytes, dest_rowbytes;
		
		cs = source->ColorSpace();
		w = source->Bounds().IntegerWidth();
		h = source->Bounds().IntegerHeight();
		
		BPoint p1(-1*sine*w,cosine*h);
		BPoint p2(cosine*w-sine*h,cosine*h+sine*w);
		BPoint p3(cosine*w,sine*w);
		
		BPoint pmin(min(0,min(p1.x,min(p2.x,p3.x))),min(0,min(p1.y,min(p2.y,p3.y))));
		BPoint pmax(max(p1.x,max(p2.x,p3.x)),max(p1.y,max(p2.y,p3.y)));
		
		int dest_width = (int)ceil(pmax.x-pmin.x);
		int dest_height = (int)ceil(pmax.y-pmin.y);
		cout << dest_width << endl;
		cout << dest_height << endl;
		
		BRect r (0, 0,dest_width,dest_height);
		bmp = new BBitmap (r, cs);
		
		src = reinterpret_cast<ftype *>(source->Bits());
		dst = reinterpret_cast<ftype *>(bmp->Bits());
		src_rowbytes = source->BytesPerRow();
		dest_rowbytes = bmp->BytesPerRow();
		int32 dstX, dstY, srcX, srcY;
		int j=0;
		int x,y;
		
		for(int32 x = 0; x < w; x++)
		{
			for(int32 y = 0; y < h; y++)
			{
				dstX = (int)((x+pmin.x)*cosine + (y + pmin.y)*sine);
				dstY = (int)((y+pmin.y)*cosine + (x + pmin.x)*sine);
				if(dstX >= 0 && dstX < w && dstY >= 0 && dstY < h)
				{
					
					//dst += (dest_rowbytes * dstY) + (dstX * pixel_width);
					//src += (src_rowbytes * srcY) + (srcX * pixel_width);
					//memcpy (dst, src, pixel_width);

					put_pixel (dst, src,  x, y,dstX, dstY, dest_rowbytes, src_rowbytes, pixel_width);
				}
			}
		}
		*/
		return NULL;//bmp;
		/*for (srcY = 0; srcY <= h; srcY++) {
			for (srcX = 0; srcX <= w; srcX++) {
				// this is where the magic happens
				
				int sbX = (int)
				
				dstX = h - srcY;
				dstY = srcX;
				put_pixel (dst, src, dstX, dstY, srcX, srcY, dest_rowbytes, src_rowbytes, pixel_width);
			}
		}*/
}
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,241,169), "Brent's Window!", B_TITLED_WINDOW, 0)
{
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	parent->SetViewColor(0,87,206);
	AddChild(parent);

	for(int i=0;i<binary_items;i++)
	{
		BBitmap* source = new BBitmap(BRect(0,0,binary_data[i].w,binary_data[i].h),B_RGB32);
		
		uint8 *p = (unsigned char*)source->Bits();
		for(int k=0;k<binary_data[i].n;k++)
		{
			p[k] = binary_data[i].p[k];
		}
		bitvec.push_back (Rotate(source,90));
	}
	IsResizing = false;

	Tile(parent,false);
}
void BrentWindow::FrameResized(float w,float h)
{
	if(!IsResizing)
		Tile(parent,true);
}
void BrentWindow::Tile(BView* v,bool IsOnlyResizing)
{
	if(IsResizing)
		return;
		
	IsResizing = true;	
	const int TileSize=23;
	BRect tiler(0,0,TileSize,TileSize);
	BRect f = v->Bounds();
	
	int num_across=0;
	float width = f.Width();
	float twidth = tiler.Width()+1;
	while(width >=0)
	{
		width -= twidth;
		num_across++;
	}
	if(width != -1)
		num_across--;	
				
	int j=1;
	for(int i=0;i<binary_items;i++)
	{
			if(!IsOnlyResizing)
			{	
				v->AddChild(new TButton(tiler,NULL,bitvec[i]));
			}else
			{
				(v->ChildAt(i))->MoveTo(tiler.LeftTop());
			}
			tiler.OffsetBy(TileSize+1,0);
			
			if(j == num_across)
			{
				tiler.left=0;
				tiler.right=TileSize;
				tiler.OffsetBy(0,TileSize+1);
				j = 0;
			}
			j++;
			
	}

	IsResizing = false;
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
void BrentWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{	
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}