#include "BrentWindow.h"

#include <string>
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,241,169), "Brent's Window!", B_TITLED_WINDOW, 0)
{
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	parent->SetViewColor(0,87,206);
	AddChild(parent);
	
	unsigned char* p;
	for(int i=0;i<mmacc_items;i++)
	{
		bitvec.push_back(new BBitmap(BRect(0,0,mmacc_data[i].w,mmacc_data[i].h),B_RGB32));
		p = (unsigned char*)bitvec[i]->Bits();
		for(int k=0;k<mmacc_data[i].n;k++)
		{
			p[k] = mmacc_data[i].p[k];
		}
	}
	IsResizing = false;

	Tile(parent,false);
}
void BrentWindow::FrameResized(float w,float h)
{
	if(!IsResizing)
		Tile(parent,true);
}
void BrentWindow::Tile(BView* v,bool IsOnlyResizing)
{
	if(IsResizing)
		return;
		
	IsResizing = true;	
	const int TileSize=23;
	BRect tiler(0,0,TileSize,TileSize);
	BRect f = v->Bounds();
	
	int num_across=0;
	float width = f.Width();
	float twidth = tiler.Width()+1;
	while(width >=0)
	{
		width -= twidth;
		num_across++;
	}
	if(width != -1)
		num_across--;	
				
	int j=1;
	for(int i=0;i<mmacc_items-2;i++)
	{
			vector<BBitmap*> Icons;
			vector<BPoint> Origins;
			if(!IsOnlyResizing)
			{	
				BPoint offset(0,-5);
				BPoint aoffset(0,3);
				if(mmacc_data[i].s == "widehat" || mmacc_data[i].s == "widetilde")
				{		
					Icons.push_back(bitvec[13]);
					offset.x = 3;
					offset.y = -10;
					aoffset.y = 0;
				}	else
						Icons.push_back(bitvec[12]);	//the "a"
					Origins.push_back(aoffset);
					
					Icons.push_back(bitvec[i]);
					Origins.push_back(offset);
					v->AddChild(new TButton(tiler,NULL,Icons,Origins));
							
			}
			else
			{
				(v->ChildAt(i))->MoveTo(tiler.LeftTop());
			}
			tiler.OffsetBy(TileSize+1,0);
			
			if(j == num_across)
			{
				tiler.left=0;
				tiler.right=TileSize;
				tiler.OffsetBy(0,TileSize+1);
				j = 0;
			}
			j++;
			
	}

	IsResizing = false;
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
void BrentWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{	
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}