#include "BrentWindow.h"

#include <string>
#include <Font.h>
//function implementation of BrentWindow() (contructor);
BrentWindow :: BrentWindow()
	: BWindow(BRect(50,50,241,169), "Brent's Window!", B_TITLED_WINDOW, 0)
{
	parent = new BView(Bounds(),"parent",B_FOLLOW_ALL,B_WILL_DRAW);
	parent->SetViewColor(0,87,206);
	AddChild(parent);
	
	/*unsigned char* p;
	for(int i=0;i<intl_items;i++)
	{
		bitvec.push_back(new BBitmap(BRect(0,0,intl_data[i].w,intl_data[i].h),B_RGB32));
		p = (unsigned char*)bitvec[i]->Bits();
		for(int k=0;k<intl_data[i].n;k++)
		{
			p[k] = intl_data[i].p[k];
		}
	}*/
	IsResizing = false;

	Tile(parent,false);
}
void BrentWindow::FrameResized(float w,float h)
{
	if(!IsResizing)
		Tile(parent,true);
}
void BrentWindow::Tile(BView* v,bool IsOnlyResizing)
{
	TButton* temp_button;
	if(IsResizing)
		return;
	
	struct text_item
	{
		const char* text;
		BFont font;
		float width;
		const char* cmd;
	};
	BFont boldfont(be_bold_font);
	BFont romanfont(be_plain_font);
	BFont emphfont(be_plain_font);
	BFont sansfont(be_plain_font);
	BFont typefont(be_plain_font);
	BFont italicfont(be_plain_font);
	italicfont.SetFace(B_ITALIC_FACE);
	italicfont.SetSize(12);//Face(B_ITALIC_FACE);
	
	emphfont.SetFace(B_ITALIC_FACE|B_BOLD_FACE);
	boldfont.SetSize(12);
	emphfont.SetSize(12);
	romanfont.SetFamilyAndStyle("Courier10 BT","Roman");
	romanfont.SetSize(14);
	sansfont.SetSize(12);
	typefont.SetFamilyAndStyle("Monospac821 BT","Roman");
	typefont.SetSize(12);
	
	BFont mediumfont(romanfont);
	mediumfont.SetSize(14);
	BFont slantfont(be_plain_font);
	slantfont.SetShear(120);
	slantfont.SetSize(12);
	
	int extra = 5;
	text_item textitems[] = {
	{"Emph",emphfont,emphfont.StringWidth("Emph")+extra,"\\emph{}"},
	{"Roman",romanfont,romanfont.StringWidth("Roman")+extra,"\\textrm{}"},
	{"Bold",boldfont,boldfont.StringWidth("Bold")+extra,"\\textbf{}"},
	{"Sans",sansfont,sansfont.StringWidth("Sans")+extra,"\\textsf{}"},
	{"TypeWriter",typefont,typefont.StringWidth("TypeWriter")+extra,"\\texttt{}"},
	{"Medium",mediumfont,mediumfont.StringWidth("Medium")+extra,"\\textmd{}"},
	{"Italic",italicfont,italicfont.StringWidth("Italic")+extra,"\\textit{}"},
	{"CAPS",sansfont,sansfont.StringWidth("CAPS")+extra,"\\textsc{}"},
	{"Slanted",slantfont,slantfont.StringWidth("Slanted")+extra,"\\textsl{}"},
	{"Verbatim",typefont,typefont.StringWidth("Verbatim")+extra,"\\verb\"\""}
	};
	int maxwidth=0;
	int num_items = 10;
	for(int m=0;m<num_items;m++)
	{
		if(textitems[m].width > maxwidth)
			maxwidth = 	(int)textitems[m].width;
	}
	
	IsResizing = true;	
	const int TileWidth=maxwidth;
	const int TileHeight=23;
	
	BRect tiler(0,0,TileWidth,TileHeight);
	BRect f = v->Bounds();
	
	int num_across=0;
	float width = f.Width();
	float twidth = tiler.Width()+1;
	while(width >=0)
	{
		width -= twidth;
		num_across++;
	}
	if(width != -1)
		num_across--;	
				
	int j=1;
	for(int i=0;i<num_items;i++)
	{
			
			if(!IsOnlyResizing)
			{	
				//BFont font(be_bold_font);
				//const char* text = "Bold";
				v->AddChild(temp_button = new TButton(tiler,NULL,textitems[i].text,textitems[i].font));
			}
			else
			{
				(v->ChildAt(i))->MoveTo(tiler.LeftTop());
			}
			tiler.OffsetBy(TileWidth+1,0);
			
			if(j == num_across)
			{
				tiler.left=0;
				tiler.right=TileWidth;
				tiler.OffsetBy(0,TileHeight+1);
				j = 0;
			}
			j++;
			
	}

	IsResizing = false;
}
// Called when the user clicks on the window's close box
bool BrentWindow :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);// tell the application to quit too
	return true; // and indicate that it's okay for us to close
}
void BrentWindow::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{	
		default:
			BWindow::MessageReceived(msg);
		break;
	}
}