#ifndef _SEARCH_WINDOW_H_
#define _SEARCH_WINDOW_H_

#include <Window.h>
#include <View.h>
#include <Button.h>
#include <iostream>
#include <Messenger.h>
#include "TexView.h"
#include "Constants.h"
#include <StringView.h>
#include <ScrollView.h>
#include <Font.h>
#include "Prefs.h"
#include <CheckBox.h>

class parentView : public BView
{
	public:
		parentView(BRect r) : BView(r,"parent",B_FOLLOW_ALL_SIDES,B_WILL_DRAW) {}
		virtual void Draw(BRect r)
		{
			BFont font(be_bold_font);
			font.SetSize(12);
			SetFont(&font);
			MovePenTo(10,25);
			DrawString("Find:");
			 MovePenTo(10,135);
			 DrawString("Replace:");
			
		}
};
class scrollView : public BScrollView
{
	public:
		scrollView(const char* name,
		BView* target,
		uint32 rmode=B_FOLLOW_LEFT|B_FOLLOW_TOP,
		uint32 flags=0,
		bool h=false,
		bool v=false,
		border_style border=B_FANCY_BORDER)
		: BScrollView(name,target,rmode,flags,h,v,border){}
		virtual void MakeFocus(bool focus=true)
		{
			Target()->MakeFocus(focus);
		}


};
class SearchWindow : public BWindow
{
	public:
		SearchWindow(BRect r,BMessenger* messenger,Prefs* p);
		~SearchWindow();
		virtual void MessageReceived(BMessage* msg);
		void Quit();
	private:
		parentView* parent;
		BMessenger* msgr;
		BButton* find;
		BButton* replace;
		BButton* replaceall;
		
		TexView* findview;
		TexView* replaceview;
		Prefs* prefs;
		
		BCheckBox* cbCaseSensitive;
		BCheckBox* cbWrapAround;
		BCheckBox* cbSearchBackwards;
		BCheckBox* cbAllDocs;
		
//		BTextView* findview;
//		BTextView* replaceview;
		
		//zStringView* fvlabel;
		//zStringView* rvlabel;
		
		
};
#endif

