#include "TListView.h"


TListView::TListView(BRect frame,BScrollView* dView) : BListView(frame,"listview",B_SINGLE_SELECTION_LIST,B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE)
{
	LastSelectedIndex = -1;
	docView = dView;
	
	IsDocViewHidden = false;
	//button = B_PRIMARY_MOUSE_BUTTON;
	//SP->AddChildTwo(docView,true,false);
}
void TListView::SelectionChanged()
{
/*	if(button == B_PRIMARY_MOUSE_BUTTON)
	{
		int current = CurrentSelection();
		if(current >= 0)
		{
			((TListItem*)ItemAt(current))->TextView()->MakeFocus();
		}
		button = B_SECONDARY_MOUSE_BUTTON;
	}
*/
	//cout << "LastItemIndex = [" << LastSelectedIndex << "]" << endl;
	if(LastSelectedIndex >= 0)
	{
		((TListItem*)ItemAt(LastSelectedIndex))->HideTextView();
	}
	//cout << "sel changed" << endl;
	BString title;
	title << "BeTeX";
	int current = CurrentSelection();
	if(current >= 0)
	{	
		BString title;
		title << "BeTeX";
		title << " - " << ((TListItem*)ItemAt(current))->FName();
		Window()->SetTitle(title.String());
		
		BMessenger msgr(Window());
		msgr.SendMessage(new BMessage(UPDATE_TEXTVIEW_SHORTCUTS));
		msgr.SendMessage(new BMessage(UPDATE_STATUSBAR));
		//((TListItem*)ItemAt(current))->ShowTextView();
			
			if(!IsDocViewHidden)
			{
				SP->AddChildTwo(docView,true,false);
				IsDocViewHidden = true;
			}
		((TListItem*)ItemAt(current))->ShowTextView();
		LastSelectedIndex = current;
	}
	else
	{
		LastSelectedIndex = -1;
			
		if(IsDocViewHidden)
		{
			SP->AddChildTwo(docView,true,true);
			if(CountItems() == 2)
			{ 
			  BString title("BeTeX");
				Window()->SetTitle(title.String());
			}
			IsDocViewHidden = false;
		}
		BMessenger msgr(Window());
		msgr.SendMessage(new BMessage(UPDATE_STATUSBAR));
	    BString title("BeTeX");
	 	Window()->SetTitle(title.String());
		
	}
	ScrollToSelection();	
}
void TListView::MouseMoved(BPoint point,uint32 transit,const BMessage* msg)
{
	switch(transit)
	{
		case B_ENTERED_VIEW:
		{
			MakeFocus(true);
		}break;
		case B_EXITED_VIEW:
		{
			MakeFocus(false);
		}break;
	}
}

void TListView::SetSP(SplitPane* sp)
{
	SP = sp;
}
void TListView::MouseDown(BPoint point)
{
	GetMouse(&point,&button);
	BListView::MouseDown(point);
}
void TListView::Next(int increment)
{
	int items = CountItems();
	if(items > 1)
	{
		int current = CurrentSelection();
		if(current >= 0)
		{
			if(current + increment < items)
			{
				Select(current+increment);
			}
			else
				Select(items-1);
		}
	}
}
void TListView::Prev(int decrement)
{
	int items = CountItems();
	if(items > 1)
	{
		int current = CurrentSelection();
		if(current >= 0)
		{
			if(current - decrement >=0)
			{
				Select(current-decrement);
			}
			else
				Select(0);
		}
	}
}
void TListView::KeyDown(const char* bytes,int32 numBytes)
{
	switch(bytes[0])
	{
		case B_HOME:
		{
			int items = CountItems();
			if(items > 0)
				Select(0);
			
		}break;
		case B_END:
		{
			int items = CountItems();
			if(items > 0)
				Select(items-1);
		}break;
		case B_PAGE_UP:
		{
			int dec = NoVisibleItems();
			Prev(dec);		
		}break;	
		case B_PAGE_DOWN:
		{
			int inc = NoVisibleItems();
			Next(inc);
		}break;	
		
		case B_UP_ARROW:
			Prev(1);	
			break;
		case B_DOWN_ARROW:
			Next(1);
			break;
		case B_DELETE:
		case B_BACKSPACE:
			Window()->PostMessage(MENU_FILE_CLOSE);
				break;
		//default:
			//BListView:KeyDown(bytes,numBytes);
			//break;	
	}
}
int TListView::NoVisibleItems()
{
	BRect r = Bounds();
	int noitems=0;
	for(int i=0;i<CountItems();i++)
	{
		if(r.Contains(ItemFrame(i)))
			noitems++;
	}
	return noitems;
}
void TListView::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case B_MOUSE_WHEEL_CHANGED:
		{	//We have a mouse wheel event when the focus is on the desktop.
					float delta_y;
					if(msg->FindFloat("be:wheel_delta_y",&delta_y) == B_OK)
					{
						int boost=1;
						if(modifiers() & B_OPTION_KEY)
							boost = NoVisibleItems();
						//Wrap-Around is taken care of too.
						if(delta_y > 0)       //move wheel down/back
						{
							Next(boost);
						}
						else if(delta_y < 0)	//move wheel up/forward
						{
							Prev(boost);	
						}
					}
						
		}break;
		default:
			BListView::MessageReceived(msg);	
		}
}

