#include "TexView.h"
#include <StopWatch.h>
#include <storage/File.h>

TexView::TexView(BRect r,BRect textRect,Prefs* p) : 
BTextView(r,"texview",textRect,B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_PULSE_NEEDED/*|B_NAVIGABLE*/)
{
	//if(p == NULL)
	//BStopWatch* construct = new BStopWatch("Construct Timer");
	prefs = p;
	IsColSel = false;
	BFont fontie(be_fixed_font);
	f = fontie;
	f.SetSize(prefs->FontSize);
	SetFontAndColor(0,1,&f,B_FONT_ALL,&prefs->fg_color);
	SetStylable(prefs->IsSyntax);
	SetAlignment(B_ALIGN_LEFT);
	//SetDoesUndo(true);
	SetAutoindent(prefs->AutoIndent);
	//IsUndo = false;
	
	IsNormalFocus = false;
	HasAttachedFocus = false;
	//TextStyles
	green_matches.push_back("textbf");
	green_matches.push_back("textit");
	green_matches.push_back("textmd");
	green_matches.push_back("textrm");
	green_matches.push_back("textsc");
	green_matches.push_back("textsf");
	green_matches.push_back("textsl");
	green_matches.push_back("texttt");
	green_matches.push_back("textup");
	green_matches.push_back("emph");

	green_matches.push_back("bf");
	green_matches.push_back("it");
	green_matches.push_back("em");
	green_matches.push_back("rm");
	green_matches.push_back("sc");
	green_matches.push_back("sf");
	green_matches.push_back("sl");
	green_matches.push_back("tt");
	green_matches.push_back("up");

	//green_matches.push_back("begin");
	//green_matches.push_back("end");

	//TextSizes
	green_matches.push_back("tiny");
	green_matches.push_back("scriptsize");
	green_matches.push_back("footnotesize");
	green_matches.push_back("small");
	green_matches.push_back("normalsize");
	green_matches.push_back("large");
	green_matches.push_back("Large");
	green_matches.push_back("LARGE");
	green_matches.push_back("huge");
	green_matches.push_back("Huge");

    green_matches.push_back("mathbb");
    green_matches.push_back("mathbf");
    green_matches.push_back("mathcal");
    green_matches.push_back("mathfrak");
    green_matches.push_back("mathit");
    green_matches.push_back("mathnormal");
    green_matches.push_back("mathrm");
    green_matches.push_back("mathsf");
    green_matches.push_back("mathtt");

    green_matches.push_back("rmfamily");
    green_matches.push_back("sffamily");
    green_matches.push_back("ttfamily");

    green_matches.push_back("itshape");
    green_matches.push_back("scshape");
    green_matches.push_back("slshape");
    green_matches.push_back("upshape");

    green_matches.push_back("bfseries");
    green_matches.push_back("mdseries");
 	
	purple_matches.push_back("author");
	purple_matches.push_back("title");
	purple_matches.push_back("section");
	purple_matches.push_back("subsection");
	purple_matches.push_back("subsubsection");
	purple_matches.push_back("subsubsubsection");
	purple_matches.push_back("verb");
	
	IsShifting = false;
/*	double construct_time = double(construct->ElapsedTime())/1000000;
	delete construct;
*/	
	// putting this in attachedtowindow would be not a good idea.
/*	BEntry entry("file.tex");
	if(entry.InitCheck() == B_OK)
	{
		entry_ref ref;
		entry.GetRef(&ref);
		LoadFile(&ref);
	}
*/
}
void TexView::ShiftLeft()
{
	int32 start,finish;
	GetSelection(&start,&finish);
	vector<int> sols;
	vector<int> eols;
	FillSolEol(sols,eols,0,TextLength()-1);//start,finish);
	int32 startline=-1;
	int32 endline=-1;
	//int TotalLines = CountLines();
	for(int i=0;i<sols.size();i++)
	{
		if(start >= sols[i] && start <= eols[i])
			startline = i;
		if(finish > sols[i] && finish <= eols[i])
			endline = i;
		else if(finish >= sols[i] && finish <= eols[i])
		{	
			endline = i-1;
			if(start == sols[i])
				endline++;
		}
		if(startline >= 0 && endline >= 0)
			break;
	}
	if(startline < 0 || endline < 0)
		return;
	
	//Select(0,0);//,start);
	//Highlight(sols[startline],eols[endline]);
	IsShifting = true;
	Select(sols[startline],sols[startline]);
	int tab_width=3;
	int offset_total=0;
	int first_offset=0;
	bool GotFirstOffset=false;
	for(int i=startline;i<=endline;i++)
	{
	//	sols[i]-= first_offset;
	//	eols[i]-= first_offset;
		int sol = sols[i]-offset_total;
		int eol = eols[i]-offset_total;
		if(//sol+2 < eol && 
		ByteAt(sol) == ' ' && ByteAt(sol+1) == ' ' && ByteAt(sol+2) == ' ')
		{
			Delete(sol,sol+3);
			offset_total+=3;
			//if(!GotFirstOffset)
			///{
			//	GotFirstOffset = true;
				first_offset=3;
			//}
			//if(startline == endline)
			//	Select(sol,eol-2);
		}
		else if(//sol+1 < eol && 
		ByteAt(sol) == ' ' && ByteAt(sol+1) == ' ')
		{
			Delete(sol,sol+2);
			offset_total+=2;
			//if(!GotFirstOffset)
			//{
			//	GotFirstOffset = true;
				first_offset=2;
			//}
			//if(startline == endline)
			//	Select(sol,eol-1);
		}  
		else if(//sol < eol && 
		ByteAt(sol) == ' ')
		{
			Delete(sol,sol+1);
			offset_total+=1;
			//if(!GotFirstOffset)
			//{
			//	GotFirstOffset = true;
				first_offset=1;
			//}
			//if(startline == endline)
			//	Select(sol,eol);
		}
		else if(//sol < eol && 
		ByteAt(sol) == '\t')
		{
			Delete(sol,sol+1);
			offset_total+=1;
			//if(!GotFirstOffset)
			//{
			//	GotFirstOffset = true;
				first_offset=1;
			//}
			//if(startline == endline)
			//	Select(sol,eol);
		}
		
		
		
	}
	//if(startline != endline)
		Select(sols[startline],eols[endline]-offset_total+1);
	IsShifting = false;
}
void TexView::ShiftRight()
{
	int32 start,finish;
	GetSelection(&start,&finish);
	vector<int> sols;
	vector<int> eols;
	FillSolEol(sols,eols,0,TextLength()-1);
	int32 startline=-1;
	int32 endline=-1;
	
	for(int i=0;i<sols.size();i++)
	{

		if(start >= sols[i] && start <= eols[i])
			startline = i;
		if(finish > sols[i] && finish <= eols[i])
			endline = i;
		else if(finish >= sols[i] && finish <= eols[i])
		{	
			endline = i-1;
			if(start == sols[i])
				endline++;
		}
		if(startline >= 0 && endline >= 0)
			break;
	}
	
	if(startline < 0 || endline < 0)
		return;
	
	IsShifting = true;
	int selection_offset = 0;
	int tab_width=3;
	
	
	int sel_start,sel_finish;
	int offset_total=0;
	Select(sols[startline],sols[startline]);
	for(int i=startline;i<=endline;i++)
	{

		int sol = sols[i]+offset_total;
		int eol = eols[i]+offset_total;
		
		Insert(sol,"   ",tab_width);
		offset_total+=tab_width;
	
	}
	Select(sols[startline],eols[endline]+offset_total+1);
	IsShifting = false;
}
void TexView::FrameResized(float w,float h)
{
	//nice resizable text
	if(w > 250 && h > 250)
	{
		BRect r = BRect(0,0,w,h);
		r.InsetBy(5,5);
		SetTextRect(r);
	}
}
bool TexView::IsBrace(char c)
{
	switch(c) {
		case '{':
		case '[':
		case '}':
		case ']':
			return true;
	}
	
	return false;
}
void TexView::AttachedToWindow()
{
	SetViewColor(prefs->bg_color);
	SetColorSpace(B_RGB32);
	BTextView::AttachedToWindow();
	//if(HasAttachedFocus)
	//{
		MakeFocus(true);
	//}

}
void TexView::Select(int32 start,int32 finish)
{
	BTextView::Select(start,finish);
	if(!IsShifting)
	{
		BMessenger msgr(Window());
		msgr.SendMessage(new BMessage(UPDATE_STATUSBAR));
	}
}
void TexView::SetNormalFocus()
{
	IsNormalFocus = true;
	
}
void TexView::SetAttachedFocus()
{
	HasAttachedFocus = true;
}
void TexView::MouseUp(BPoint point)
{
	//IsColSel = false;
	BTextView::MouseUp(point);
}
void TexView::Draw(BRect r)
{
	BTextView::Draw(r);
/*	if(IsColSel)
	{
		
		BRect ColumnRect(ColStart,ColFinish);
		//SetHighColor(0,255,0,128);
		//SetDrawingMode(B_OP_ALPHA);
		InvertRect(ColumnRect);
	}
*/
}
void TexView::MouseMoved(BPoint point,uint32 transit,const BMessage* msg)
{
	if(!IsNormalFocus)
	{
		switch(transit)
		{
			case B_ENTERED_VIEW:
			{
				MakeFocus(true);
			}break;
			case B_EXITED_VIEW:
			{
				MakeFocus(false);
			}break;
		}
	}
	/*
	int32 offset = OffsetAt(point);
	BString theUrl = FindUrl(offset);
	bool IsValidUrl = theUrl.Length() > 0;
	#ifdef B_BEOS_VERSION_5
    	SetViewCursor(IsValidUrl ? B_CURSOR_SYSTEM_DEFAULT : B_CURSOR_I_BEAM);
	#else
   	   	be_app->SetCursor(IsValidUrl ? B_HAND_CURSOR : B_I_BEAM_CURSOR);
	#endif*/
	//if(IsValidUrl)
	//{
		
		//char* url = (char*)theUrl.String();
		//be_roster->Launch("text/html",1,&url);
	//}

/*	if(IsColSel)
	{
		ColFinish = point;
		float height = LineHeight();
		
		//BPoint ColTopRight(ColFinish.x,ColStart.y);
		//BPoint ColBtmLeft(ColStart.x,ColFinish.y);
		//Invalidate();
		//if(ColFinish != point)
		//{
		ParseAll(OffsetAt(ColStart),OffsetAt(ColFinish));
		for(float i=ColStart.y;i<=ColFinish.y;i+=height)
		{
			int32 start,finish;
			start = OffsetAt(BPoint(ColStart.x,i));
			finish = OffsetAt(BPoint(ColFinish.x,i));
			//Highlight(start,finish);
			rgb_color y_col = {255,255,0};
			
			SetFontAndColor(start,finish,&f,B_FONT_ALL,&y_col);
		}
		//}
	
	}
	else*/
		BTextView::MouseMoved(point,transit,msg);
}
/*bool TexView::IsBadUrlChar(int32 h)
{
	if(IsBrace(ByteAt(h)))
		return true;
	if(ByteAt(h) == ' ' || ByteAt(h) == '(' || ByteAt(h) == ')' || ByteAt(h) == '|'
	|| ByteAt(h) == '\\'|| ByteAt(h) == '\n')
		return true;
	return false;
}
bool TexView::IsUrlCommented(int32 start,int32 finish)
{
	text_run_array* tra = RunArray(start,finish);
	if(tra == NULL)
		return false;
	return (tra->count == 1 && tra->runs[0].color == prefs->comment_color);
}
BString TexView::FindUrl(int32 offset)
{
	BString url="";
	if(IsBadUrlChar(offset))
		return url;
	int text_length = TextLength();
	vector<int> sols;
	vector<int> eols;
	FillSolEol(sols,eols,offset,offset+1);
	
	if(sols.size() != eols.size())
		return url;
	int sol = sols[0];
	int eol = eols[0];
	
	
	int i;
	int start=-1;
	//try looking left
	bool DoneSearch=false;
	for(i=offset;i>=sol;i--)
	{
		if(IsBadUrlChar(i))
		{
			start = i+1;
			DoneSearch = true;
			break;
		}
	}	
	if(DoneSearch == false)
		start = sol;
				
	DoneSearch=false;	
	int finish = -1;
	for(i=offset;i<eol;i++)
	{
		if(IsBadUrlChar(i))
		{
			finish = i-1;
			DoneSearch = true;
			break;
		}
	}	
	if(DoneSearch == false)
		finish = eol-1;
	
	
	if(start < 0 || finish < 0 || IsUrlCommented(start,finish))
		return url;
	
	if(start +1 < text_length &&
	start +2 < text_length &&
	start +3 < text_length &&
	start +4 < text_length &&
	start +5 < text_length &&
	start +6 < text_length &&
	ByteAt(start) == 'h' &&
	ByteAt(start+1) == 't' &&
	ByteAt(start+2) == 't' &&
	ByteAt(start+3) == 'p' &&
	ByteAt(start+4) == ':' &&
	ByteAt(start+5) == '/' &&
	ByteAt(start+6) == '/')
	{
		for(i=start;i<=finish;i++)
		{
			//if(i==finish)
				url <<(char)ByteAt(i);//= strcat(url,(const char*)ByteAt(i));
			//else
			//	strcat(url,(const char*)ByteAt(i));
		}	
	}
	return url;
	
//	return NULL;
	//try looking right
	


}*/
int32 TexView::CountPhysicalLines()
{
	return BTextView::CountLines();
}
void TexView::MouseDown(BPoint point)
{
	/*int32 offset = OffsetAt(point);
	BString theUrl = FindUrl(offset);
	if(theUrl.Length() > 0)
	{
		char* url = (char*)theUrl.String();
		be_roster->Launch("text/html",1,&url);
	}*/
	/*if(modifiers() & B_CONTROL_KEY)
	{
		IsColSel = true;
		ColStart = point;
	
	
	}
	else*/
		BTextView::MouseDown(point);
}
void TexView::KeyDown(const char* bytes, int32 numBytes)
{
	switch(bytes[0])
	{
		case B_ENTER:
		{
			//update previous line on enter
			BMessage msg(PARSE_LINE);
			int32 start,finish;
			GetSelection(&start,&finish);
			if(msg.AddInt32("start",start) == B_OK
			&& msg.AddInt32("finish",finish) == B_OK)
			Window()->PostMessage(&msg,this);
		}break;
		
		case B_TAB:
		{
			if(IsNormalFocus)
			{
				Parent()->NextSibling()->MakeFocus();
				return;
			}
		} break;
	}
		
		
	BTextView::KeyDown(bytes,numBytes);
	BMessenger msgr(Window());
	msgr.SendMessage(new BMessage(UPDATE_STATUSBAR));
}

int TexView::FindFirstOnLine(char c,int offset,int eol)
{
	for(int i=offset;i<eol;i++)
	{
		if(ByteAt(i) == c)
			return i;
	}
	return -1;
}

int32 TexView::OffsetAtIndex(int32 index) //const
{
	//int text_length = TextLength();
	int i;
	//if(index <= 0)
	//	return 0;
	int count = 0;
	int last=0;
	for(i=0;count < index;i++)
	{
		if(ByteAt(i) == '\n')
		{
			count++;
			last = i+1;
		}
	}
	return last;	
}
int32 TexView::OffsetAt(BPoint point)
{
	return BTextView::OffsetAt(point);
}

int32 TexView::LineAt(int32 offset) //const
{
	vector<int> sols;
	vector<int> eols;
	FillSolEol(sols,eols,0,TextLength()-1);

	for(int i=0;i<sols.size();i++)
	{
		if(offset >= sols[i] && offset <= eols[i])
			return i;
	}
	return -1;
}
void TexView::FillSolEol(vector<int>& s,vector<int>& e,int start,int finish)
{
	int i=start;
	int text_length = TextLength();
	for(i=start;i>=0;i--)
	{
		if(ByteAt(i) == '\n')
		{
			break;
		}
	}
	start=i+1;
	
	i = finish;	
	for(i=finish;i<text_length;i++)
	{
		if(ByteAt(i) == '\n')
		{
			break;
		}
	}
	finish=i;
	
	for(i=start;i<=finish;i++)
	{
		if(ByteAt(i) == '\n')
		{
			e.push_back(i);
		}
	}
	
	e.push_back(i);
	
	s.push_back(start);
	for(i=0;i<e.size()-1;i++)
	{
		s.push_back(e[i]+1);
	}
	//s.push_back(e[i]);
}
void TexView::GoToLine(int32 index)
{
	if(index < 0 || index > CountLines() || TextLength() <= 0)
		return;
		
	vector<int> eols;
	vector<int> sols;
	
	FillSolEol(sols,eols,0,TextLength()-1);
	Select(sols[index],eols[index]);
}
int32 TexView::CountLines()
{
	vector<int> eols;
	vector<int> sols;
	FillSolEol(sols,eols,0,TextLength()-1);	
	return eols.size();
}
void TexView::ParseAll(int start,int finish,bool IsInteractive)
{
	BFont font(be_fixed_font);
	font.SetSize(prefs->FontSize);
	
	int text_length = TextLength();
	if(text_length > 0)
	{
		vector<int> eols;
		vector<int> sols;
		FillSolEol(sols,eols,start,finish);
		
		int i;
		int size;
		
		if(!IsInteractive)
		{
			size = text_length;
			vector<rgb_color> colorVec(size,prefs->fg_color);

			for(i=0;i<sols.size();i++)
			{
				ParseLine(sols[i],eols[i],colorVec);		
			}
			
			int offset_size=1;
			vector<int> offsets;
			offsets.push_back(0);
			
			for(i=1;i<size;i++)
			{
				if(colorVec[i-1] != colorVec[i])
				{
					offsets.push_back(i);	
					offset_size++;
				}
			}
			text_run_array* tra = (text_run_array*)malloc(sizeof(text_run_array)*(size));
			tra->count = offset_size;
			for(i=0;i<offset_size;i++)
			{
				tra->runs[i].color=colorVec[offsets[i]];
				tra->runs[i].font=font;
				tra->runs[i].offset=offsets[i];
			}
			SetRunArray(0,text_length-1,tra);
		}		
		else
		{
			for(i=0;i<sols.size();i++)
			{
				IParseLine(sols[i],eols[i]);		
			}
		}
	}
}
void TexView::IParseLine(int sol,int eol)
{
		int size = eol-sol+1;
		vector<rgb_color> colorVec(size,prefs->fg_color);
		
		//rgb_color colorVec[size];// = prefs->fg_color;
		//rgb_color old_colors[size];
		for(int k=0;k<size;k++)
		{
			colorVec[k] = prefs->fg_color;
			//old_colors[k] = prefs->fg_color;
			
		}
		int i;
		int offset = sol;
		int pos;
		int text_length = TextLength();
		//assert(sol >=0 && eol >=0 && sol < text_length && eol < text_length);
		//Setup some defaults....
		ITwoColorPlateau('\'',sol,eol,prefs->comma_color,colorVec);//,displaced);//-displaced
		ITwoColorPlateau('`',sol,eol,prefs->comma_color,colorVec);//,displaced);
		ITwoColorPlateau('\\',sol,eol,prefs->punc_symbol_color,colorVec);//,displaced);

		for(i=sol;i<eol;i++)
		{
			if(ByteAt(i) == '[' || ByteAt(i) == ']')
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1-sol] = prefs->punc_symbol_color;
				}
					
				colorVec[i-sol] = prefs->punc_symbol_color;			
				
			}
			else if(ByteAt(i) == '&' || ByteAt(i) == '{' || ByteAt(i) == '}')//
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1-sol] = prefs->punc_symbol_color;
				}
					
				colorVec[i-sol] = prefs->punc_symbol_color;			
				
			}
			else if(ByteAt(i) == '$')
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1-sol] = prefs->fg_color;
					colorVec[i-sol] = prefs->fg_color;
				}
			}
			else if(ByteAt(i) == '\\' && i+1 < eol)
			{
				if(ByteAt(i+1) == '#')
				{	
					colorVec[i-sol] = prefs->punc_symbol_color;
					colorVec[i+1-sol] = prefs->punc_symbol_color;
				}else if(ByteAt(i+1) == '\'' || ByteAt(i+1) == '`')
				{
					colorVec[i-sol] = prefs->fg_color;
					colorVec[i+1-sol] = prefs->fg_color;
				}
			}
			
			/*else if(ByteAt(i) == 'h')
			{
				if(i+1 < eol && ByteAt(i+1) == 't' && i+2 < eol && ByteAt(i+2) == 't' && i+3 < eol && ByteAt(i+3) == 'p'
				&& i+4 < eol && ByteAt(i+4) == ':' && i+5 < eol && ByteAt(i+5) == '/' && i+6 < eol && ByteAt(i+6) == '/')
				{
					int h=i;
					while(h < eol && !IsBadUrlChar(h))// != ' ')
					{
						colorVec[h-sol] = prefs->html_color;
						h++;
					}		
				}
			}*/
			
			
		}
		offset = sol;
		/*int url_pos;
		int url_last;
		url_pos = FindFirstUrlOnLine(offset,eol);
		url_last = FindLastUrlPos(url_pos,eol);
		*/
		while((pos = FindFirstOnLine('%',offset,eol))>= 0 && offset < eol)
		{
			
		/*	if(pos > url_last)
			{
				url_pos = FindFirstUrlOnLine(url_last,eol);

				url_last = FindLastUrlPos(url_pos,eol);
			}
			if(url_pos < 0 || (pos < url_pos || pos > url_last))
			{
			*/	if(pos - 1 >= 0 && ByteAt(pos-1) == '\\')
				{
						colorVec[pos-1-sol] = prefs->punc_symbol_color;
						colorVec[pos-sol] = prefs->punc_symbol_color;
				}
				else 
				{
					for(i=pos;i<eol;i++)
						colorVec[i-sol] = prefs->comment_color;
					break;
				}
			//}
			offset= pos+1;
		}	
		
		//START COLOURING***********************************
			
				BFont default_font(be_fixed_font);
				default_font.SetSize(prefs->FontSize);

				/*rgb_color c;
				BFont tmpfont;
				//vector<rgb_color> old_colors(size);
				vector<rgb_color> old_colors;//(size);//,prefs->fg_color);
				
				
				for(i=sol;i<=eol;i++)
				{
					GetFontAndColor(i,&tmpfont,&c);
					old_colors.push_back(c);//[i-sol] = c;	
				}
*/
/*				for(i=sol;i<eol;i++)
				{
					SetFontAndColor(i,i+1,&default_font,B_FONT_ALL,&colorVec[i-sol]);
				}
*/
				int plLength=0;
				int plStart=0;
				for(i=sol;i<eol;i++)
				{
					if(i == sol)
					{
						plLength = 1;
						plStart = i;
					}
					else if(colorVec[i-sol] != colorVec[i-sol-1])
					{
						//if(colorVec[i-sol-1] != old_colors[i-sol])
							SetFontAndColor(plStart,plStart+plLength,&default_font,B_FONT_ALL,&colorVec[i-sol-1]);		
						
						plLength = 1;
						plStart = i;
					}
					else
					{
						plLength++;
					}	
				}
				
				if(plLength > 0)
					SetFontAndColor(plStart,plStart+plLength,&default_font,B_FONT_ALL,&colorVec[i-sol-1]);	

}
void TexView::ParseLine(int sol,int eol,vector<rgb_color>& colorVec)//,vector<rgb_color>& colorVec)
{
		int i;
		int offset = sol;
		int pos;
		int text_length = TextLength();
		//assert(sol >=0 && eol >=0 && sol < text_length && eol < text_length);
		//Setup some defaults....
		TwoColorPlateau('\'',sol,eol,prefs->comma_color,colorVec);//,displaced);//-displaced
		TwoColorPlateau('`',sol,eol,prefs->comma_color,colorVec);//,displaced);
		TwoColorPlateau('\\',sol,eol,prefs->punc_symbol_color,colorVec);//,displaced);

		for(i=sol;i<eol;i++)
		{
			if(ByteAt(i) == '[' || ByteAt(i) == ']')
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1] = prefs->punc_symbol_color;
				}
					
				colorVec[i] = prefs->punc_symbol_color;			
				
			}
			else if(ByteAt(i) == '&' || ByteAt(i) == '{' || ByteAt(i) == '}')//
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1] = prefs->punc_symbol_color;
				}
					
				colorVec[i] = prefs->punc_symbol_color;			
				
			}
			else if(ByteAt(i) == '$')
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1] = prefs->fg_color;
					colorVec[i] = prefs->fg_color;
				}
			}
			else if(ByteAt(i) == '\\' && i+1 < eol)
			{
				if(ByteAt(i+1) == '#')
				{	
					colorVec[i] = prefs->punc_symbol_color;
					colorVec[i+1] = prefs->punc_symbol_color;
				}else if(ByteAt(i+1) == '\'' || ByteAt(i+1) == '`')
				{
					colorVec[i] = prefs->fg_color;
					colorVec[i+1] = prefs->fg_color;
				}
			}
			
			/*else if(ByteAt(i) == 'h')
			{
				if(i+1 < eol && ByteAt(i+1) == 't' && i+2 < eol && ByteAt(i+2) == 't' && i+3 < eol && ByteAt(i+3) == 'p'
				&& i+4 < eol && ByteAt(i+4) == ':' && i+5 < eol && ByteAt(i+5) == '/' && i+6 < eol && ByteAt(i+6) == '/')
				{
					int h=i;
					while(h < eol && !IsBadUrlChar(h))// != ' ')
					{
						colorVec[h] = prefs->html_color;
						h++;
					}		
				}
			}*/
		}
		offset = sol;
		/*int url_pos;
		int url_last;
		url_pos = FindFirstUrlOnLine(offset,eol);
		url_last = FindLastUrlPos(url_pos,eol);
		*/
		while((pos = FindFirstOnLine('%',offset,eol))>= 0 && offset < eol)
		{
			
			/*if(pos > url_last)
			{
				url_pos = FindFirstUrlOnLine(url_last,eol);

				url_last = FindLastUrlPos(url_pos,eol);
			}
			if(url_pos < 0 || (pos < url_pos || pos > url_last))
			{*/
				if(pos - 1 >= 0 && ByteAt(pos-1) == '\\')
				{
						colorVec[pos-1] = prefs->punc_symbol_color;
						colorVec[pos] = prefs->punc_symbol_color;
				}
				else 
				{
					for(i=pos;i<eol;i++)
						colorVec[i] = prefs->comment_color;
					break;
				}
			//}
			offset= pos+1;
		}	
}
/*int TexView::FindLastUrlPos(int h,int eol)
{
	if(h < 0)
		return -1;
	for(int i=h;i<eol;i++)
	{
		if(IsBadUrlChar(i))
			return i-1;
	}
	return eol;
}
int TexView::FindFirstUrlOnLine(int offset,int eol)
{
	int h=-1;
	bool IsUrl=false;
	
	while(h < eol && !IsUrl)
	{
		h = FindFirstOnLine('h',offset,eol);
		if(h < 0)
			return -1;
		IsUrl=(h+1 < eol &&
		h+2 < eol &&
		h+3 < eol &&
		h+4 < eol &&
		h+5 < eol &&
		h+6 < eol &&
		ByteAt(h+1) == 't' &&
		ByteAt(h+2) == 't' &&
		ByteAt(h+3) == 'p' &&
		ByteAt(h+4) == ':' &&
		ByteAt(h+5) == '/' &&
		ByteAt(h+6) == '/');	
		if(IsUrl)
			return h;
			
		offset = h+1;
	}
	return h;	
}*/
void TexView::TwoColorPlateau(char c,int sol,int eol,rgb_color c1,vector<rgb_color>& colorVec)
{
		int IsPlateau = false;
		int plLength = 0;
		int plStart;
		int i;
		for(i=sol;i<eol;i++)
		{
			//start a plateau
			if(c == '\\' && !IsPlateau && ByteAt(i) == c)
			{
				plStart = i;
				plLength++;
				IsPlateau = true;
			}
			else if(c != '\\' && !IsPlateau && ByteAt(i) == c &&  i - 1 >= 0 && ByteAt(i-1) != '\\')
			{
				plStart = i;
				plLength++;
				IsPlateau = true;
			}
			else if(IsPlateau && ByteAt(i) == c && i - 1 >= 0 && ByteAt(i-1) == c)
			{
				plLength++; 			
			}
			else if(IsPlateau && ByteAt(i) != c && i - 1 >= 0 && ByteAt(i-1) == c)
			{
				if(plLength % 2 == 0)
				{	
						for(int k=plStart;k<plStart+plLength;k++)
						{	
							colorVec[k] = c1;
						}
				}
				else
				{
						
					for(int k=plStart;k<plStart+plLength-1 && k < eol;k++)
					{
							colorVec[k] = c1;
					}
					if(c == '\\' && isalpha(ByteAt(i)))
					{
						BString match="";
						
						int j=i;
						for(j=i;j < eol;j++)
						{
							if(isalpha(ByteAt(j)))
								match << (char)ByteAt(j);
							else
								break;
						}
						if(match.Length() > 0)
						{			
							if(Contains(green_matches,match))
							{
									for(int k=i-1;k<j;k++)
										colorVec[k] = prefs->format_cmd_color;
							}
							else if(Contains(purple_matches,match))
							{
									for(int k=i-1;k<j;k++)
										colorVec[k] = prefs->special_cmd_color;
							}
							else 
							{	for(int k=i-1;k<j;k++)
										colorVec[k] = prefs->generic_cmd_color;
							}
						}
					}	
					else
					{
							colorVec[plStart+plLength-1] = prefs->fg_color;
							colorVec[plStart+plLength] = prefs->fg_color;
					}
					
				}

				IsPlateau = false;
				plLength = 0;
			}
		}
		if(IsPlateau)
		{
				if(plLength % 2 == 0)
				{	
						for(int k=plStart;k<plStart+plLength;k++)
						{	
							colorVec[k] = c1;
						}
					
				}else
				{
						for(int k=plStart;k<plStart+plLength-1 && k < eol;k++)
						{
							colorVec[k] = c1;
						}
					
					if(c == '\\' && isalpha(ByteAt(i)))
					{
						BString match="";
						
						int j=i;
						for(j=i;j < eol;j++)
						{
							if(isalpha(ByteAt(j)))
								match << (char)ByteAt(j);
							else
								break;
						}
						if(match.Length() > 0)
						{			
							if(Contains(green_matches,match))
							{
									for(int k=i-1;k<j;k++)
										colorVec[k] = prefs->format_cmd_color;
							}
							else if(Contains(purple_matches,match))
							{
									for(int k=i-1;k<j;k++)
										colorVec[k] = prefs->special_cmd_color;
							}
							else 
							{
									for(int k=i-1;k<j;k++)
										colorVec[k] = prefs->generic_cmd_color;
							}
						}
					}	
					else
					{
							colorVec[plStart+plLength-1] = prefs->fg_color;
							colorVec[plStart+plLength] = prefs->fg_color;						
					}
				
				}

				IsPlateau = false;
				plLength = 0;
		}

}
void TexView::ITwoColorPlateau(char c,int sol,int eol,rgb_color c1,vector<rgb_color>& colorVec)
{
		int IsPlateau = false;
		int plLength = 0;
		int plStart;
		int i;
		for(i=sol;i<eol;i++)
		{
			//start a plateau
			if(c == '\\' && !IsPlateau && ByteAt(i) == c)
			{
				plStart = i;
				plLength++;
				IsPlateau = true;
			}
			else if(c != '\\' && !IsPlateau && ByteAt(i) == c &&  i - 1 >= 0 && ByteAt(i-1) != '\\')
			{
				plStart = i;
				plLength++;
				IsPlateau = true;
			}
			else if(IsPlateau && ByteAt(i) == c && i - 1 >= 0 && ByteAt(i-1) == c)
			{
				plLength++; 			
			}
			else if(IsPlateau && ByteAt(i) != c && i - 1 >= 0 && ByteAt(i-1) == c)
			{
				
				if(plLength % 2 == 0)
				{	
						for(int k=plStart;k<plStart+plLength;k++)
						{	
							colorVec[k-sol] = c1;
						}
				}
				else
				{
					for(int k=plStart;k<plStart+plLength-1 && k < eol;k++)
					{
							colorVec[k-sol] = c1;
					}
					colorVec[plStart+plLength-sol] = prefs->fg_color;
				//else
				//{
						
					//for(int k=plStart-sol;k<plStart+plLength-1-sol && k-sol < eol;k++)
					//{
					//if(plLength % 2 != 0)
					//	colorVec[plStart+plLength-sol-1] = prefs->fg_color;
					//}
					//if(!(plLength % 2 == 0 && i-1 >=0 && i-1 == plStart+plLength))  
					
					if(c == '\\' && isalpha(ByteAt(i)))
					{
						BString match="";
						
						int j=i;
						for(j=i;j < eol;j++)
						{
							if(isalpha(ByteAt(j)))
								match << (char)ByteAt(j);
							else
								break;
						}
						if(match.Length() > 0)
						{			
							if(Contains(green_matches,match))
							{
									for(int k=i-1;k<j;k++)
										colorVec[k-sol] = prefs->format_cmd_color;
							}
							else if(Contains(purple_matches,match))
							{
									for(int k=i-1;k<j;k++)
										colorVec[k-sol] = prefs->special_cmd_color;
							}
							else 
							{	for(int k=i-1;k<j;k++)
										colorVec[k-sol] = prefs->generic_cmd_color;
							}
						}
					}
					else
					{
							colorVec[plStart+plLength-1-sol] = prefs->fg_color;
							//if(plLength %2 == 0)
							colorVec[plStart+plLength-sol] = prefs->fg_color;
					}
					
				}
		
				/*	else
					{
						colorVec[plStart+plLength-1-sol] = prefs->fg_color;	
						//colorVec[plStart+plLength-sol] = prefs->fg_color;
						//colorVec[plStart+plLength-1-sol] = prefs->fg_color;						
					}*/
					
				

				IsPlateau = false;
				plLength = 0;
			}
		}
		if(IsPlateau)
		{
				//{	
				//else
				//{
				
					//for(int k=plStart-sol;k<plStart+plLength-1-sol && k-sol < eol;k++)
					//{
					//if(plLength % 2 != 0)
					//	colorVec[plStart+plLength-sol-1] = prefs->fg_color;
					//}
				if(plLength % 2 == 0)
				{	
						for(int k=plStart;k<plStart+plLength;k++)
						{	
							colorVec[k-sol] = c1;
						}
				}
				else
				{
					for(int k=plStart;k<plStart+plLength-1 && k < eol;k++)
					{
							colorVec[k-sol] = c1;
					}
					colorVec[plStart+plLength-sol] = prefs->fg_color;
					if(c == '\\' && isalpha(ByteAt(i)))
					{
						BString match="";
						
						int j=i;
						for(j=i;j < eol;j++)
						{
							if(isalpha(ByteAt(j)))
								match << (char)ByteAt(j);
							else
								break;
						}
						if(match.Length() > 0)
						{			
							if(Contains(green_matches,match))
							{
									for(int k=i-1;k<j;k++)
										colorVec[k-sol] = prefs->format_cmd_color;
							}
							else if(Contains(purple_matches,match))
							{
									for(int k=i-1;k<j;k++)
										colorVec[k-sol] = prefs->special_cmd_color;
							}
							else 
							{	for(int k=i-1;k<j;k++)
										colorVec[k-sol] = prefs->generic_cmd_color;
							}
						}
					}	
					else
					{
							colorVec[plStart+plLength-1-sol] = prefs->fg_color;
						//	if(plLength %2 == 0)
							colorVec[plStart+plLength-sol] = prefs->fg_color;
					}
					
				}
				
				/*	else
					{
						colorVec[plStart+plLength-1-sol] = prefs->fg_color;	
						//colorVec[plStart+plLength-sol] = prefs->fg_color;
						//colorVec[plStart+plLength-1-sol] = prefs->fg_color;						
					}*/
					
					
				

				IsPlateau = false;
				plLength = 0;
			}
			
}
int TexView::IsMathMode(int offset/*,int sol,int eol*/,vector<BString>& v,bool IsStart/*,bool& IsMultiLine*/)
{
	for(int i=0;i<v.size();i++)
	{
		//try all possibilities....
		if(/*offset < eol &&*/ByteAt(offset) == v[i].ByteAt(0))
		{
			//should be fixed to incorporate sol -- maybe not!
			if(offset-1 >= 0/*!= sol*/ && ByteAt(offset-1) == '\\')
				return -1;
				
			int len = v[i].Length();
			
//			else
//			{
				bool IsOk=true;
				int j=1;
				while(IsOk && j < len)
				{
					IsOk = (ByteAt(offset+j) == v[i].ByteAt(j));
					j++;
				}
				if(IsOk == true)
				{
					//IsMultiLine = true;//(i >=2);
					if(len > 2)
					{
						if(IsStart)
						return offset+j;
							else
						return offset;
					}
					else
					{
						if(IsStart)
							return offset;
						else
							return offset+j;
					}
					
				}
//			}		
		}
	}
	return -1;
}
void TexView::SetMathModes(vector<rgb_color>& colorVec)//,vector<BFont>& fontVec)
{
	vector<BString> start;
	vector<BString> end;
/*
		\begin{equation}
		\end{equation}
		\begin{displaymath}
		\end{displaymath}
		\begin{math}
		\end{math}
		\begin{eqnarray}
		\end{eqnarray}
		\begin{eqnarray*}
		\end{eqnarray*}
*/	
	start.push_back("$");
	start.push_back("\\[");
	start.push_back("\\begin{eqnarray*}");
	start.push_back("\\begin{eqnarray}");
	start.push_back("\\begin{equation}");
	start.push_back("\\begin{displaymath}");
	start.push_back("\\begin{math}");
	start.push_back("\\begin{verbatim}");
	
	end.push_back("$");
	end.push_back("\\]");
	end.push_back("\\end{eqnarray*}");
	end.push_back("\\end{eqnarray}");
	end.push_back("\\end{equation}");
	end.push_back("\\end{displaymath}");
	end.push_back("\\end{math}");
	end.push_back("\\end{verbatim}");
	
	int i;
	int32 spos;
	int32 fpos=-1;
	//bool IsMultiLine;
	int length=TextLength();
	
	for(i=0;i<length;i++)
	{
		if((spos = IsMathMode(i/*,sol,eol*/,start,true/*,IsMultiLine*/)) >= 0)
		{
			int k=spos+1;
			//int limit=TextLength();
			/*if(IsMultiLine)
			{
				limit=TextLength();
			}*/
			for(k=spos+1;k<length;k++)
			{
				if((fpos = IsMathMode(k,/*sol,eol,*/end,false/*,IsMultiLine*/)) >= 0)
					break;	
			}
			if(fpos == -1)
				fpos=length;
			
			for(int p=spos;p<fpos;p++)
			{
				colorVec[p] = prefs->math_mode_color;
			}
			i = k;
		}
	}
}

void TexView::InsertText(const char* text,int32 length,int32 offset,const text_run_array* runner)
{
	
	BTextView::InsertText(text,length,offset,NULL);
	
	if(!IsShifting && text[0] != B_ENTER)
	{
		BMessage msg(ANALYSE_TEXVIEW);
		if(msg.AddInt32("offset",offset)==B_OK
		&& msg.AddInt32("length",length)==B_OK)
		//&& msg.AddString("text",text) == B_OK)
		Window()->PostMessage(&msg,this);
		
	}
	Window()->PostMessage(new BMessage(FILE_CONTENTS_CHANGED));
}
void TexView::DeleteText(int32 start, int32 finish)
{
	if(!IsShifting)
	{
		BMessage msg(ANALYSE_TEXVIEW);
		if(msg.AddInt32("start",start)==B_OK
		&& msg.AddInt32("finish",finish)==B_OK)
		Window()->PostMessage(&msg,this);
	}
	BTextView::DeleteText(start,finish);
	Window()->PostMessage(new BMessage(FILE_CONTENTS_CHANGED));	
}


void TexView::SetText(const char* text,int32 length,const text_run_array* runs = NULL)
{
	BTextView::SetText(text,length,runs);
	ParseAll(0,length-1,false);
}
void TexView::UpdateColors()
{
	SetFontAndColor(0,TextLength(),&f,B_FONT_ALL,&prefs->fg_color);
	ParseAll(0,TextLength()-1,true);	
	//const char* text = Text();
	//Delete(0,TextLength()-1);
	//SetText(text,strlen(text));//,TextLength()-1);
}
void TexView::UpdateFontSize()
{
	f.SetSize(prefs->FontSize);
	SetFontAndColor(0,TextLength(),&f,B_FONT_ALL,&prefs->fg_color);
	ParseAll(0,TextLength()-1,true);	
}

void TexView::SetText(BFile* file,int32 offset,int32 length,const text_run_array* runs = NULL)
{
	BTextView::SetText(file,offset,length,runs);
	ParseAll(offset,length-1,false);
}
bool TexView::Contains(vector<BString>& v,BString s)
{
	for(int i=0;i<v.size();i++)
	{
		if(v[i] == s)
			return true;
	}
	return false;
}
bool TexView::CanEndLine(int32 offset)
{
	if(ByteAt(offset) == B_ENTER)
		return true;
	else
		return false;
}
int32 TexView::GetMathSol(int sol)
{
	/*bool IsMultiLine;
	vector<BString> start;
	start.push_back("$");
	start.push_back("\\[");
	start.push_back("\\begin{eqnarray*}");
	start.push_back("\\begin{eqnarray}");
	start.push_back("\\begin{equation}");
	start.push_back("\\begin{displaymath}");
	start.push_back("\\begin{math}");
	const char* text;
	int32 text_length = TextLength();
	int retval=-1;
	for(int i=sol;i>=0;i--)
	{
		if(retval = (IsMathMode(i,i,0,start,true,IsMultiLine) > 0))
			return retval;
	}
	return retval;
	*/
	return sol;
}
void TexView::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case UNDO_HIGHLIGHTING:
		{
			int32 start,finish;
			if(msg->FindInt32("start",&start)==B_OK
			&& msg->FindInt32("finish",&finish)==B_OK
			)
			{			
				Select(start,finish);
			}
		}break;
		
		case PARSE_LINE:
		{
			int32 start,finish;
			if(msg->FindInt32("start",&start)==B_OK
			&& msg->FindInt32("finish",&finish)==B_OK
			)
			{	
				int32 sel_start,sel_finish;
				GetSelection(&sel_start,&sel_finish);
				ParseAll(min(sel_start,start),max(sel_finish,finish),true);
		}	
		}break;
		case ANALYSE_TEXVIEW:
		{		
			int32 start,finish;
			if(msg->FindInt32("start",&start)==B_OK
			&& msg->FindInt32("finish",&finish)==B_OK)
			{			
				ParseAll(start,finish,true);
			}
			
			int32 offset,length;
			if(msg->FindInt32("offset",&offset)==B_OK
			&& msg->FindInt32("length",&length)==B_OK)
			{
				GetSelection(&start,&finish);
				ParseAll(offset,finish,true);			
			}

		}break;
		
		case B_CUT:
		case B_COPY:
		case B_PASTE:
		{
			BMessage msg(UPDATE_CLIPBOARD_MENU_STATUS);
			Window()->PostMessage(&msg,this);
		}
		default:
			BTextView::MessageReceived(msg);
			
	}
}
void TexView::LoadFile (entry_ref *ref)
{
	if (ref == NULL) {
		return;
	}
	
	BFile file(ref, B_READ_ONLY);
	if (file.InitCheck() != B_OK) {
		return;
	}
	
	off_t length;
	file.GetSize(&length);
	if (length == 0) {
		return;
	}
	
	SetText (&file, 0, length);
}
							//if(match == "textbf" || match == "textit"|| match == "bf"|| match == "it"
							//|| match == "emph" || match == "em" || match == "textsl" || match == "sl")
							//{
						/*		if(j < eol && text[j] == '{')
								{
									int numleft=1;
									int numright=0;
									int start=j+1;
									int q;
									for(q=j+1;q<eol;q++)
									{
										if(text[q] == '}')
										{
											numright++;
											//break;
										}
										else if(text[q] == '{')
										{
											numleft++;
											//break;
										}
										if(numleft == numright)
											break;
									}
								
									if(match == "textbf" || match == "bf")
										f.SetFace(B_BOLD_FACE);
									else if(match == "textit" || match == "it")
										f.SetFace(B_ITALIC_FACE);
									else if(match == "emph" || match == "em")
										f.SetFace(B_BOLD_FACE | B_ITALIC_FACE);
									else if(match == "textsl" || match == "sl")
										f.SetShear(120);
										
									//SetFontAndColor(start,q,&f,B_FONT_ALL,&prefs->fg_color);	
									//if(IsRecording)
									//{
										for(int k=start;k<q;k++)
										{	
											colorVec[k-sol] = prefs->fg_color;
											fontVec[k-sol] = f;
										}	
									//}
									
									f.SetFace(B_REGULAR_FACE);
									f.SetShear(90);
									
									
									//if(q < eol && text[q] == '}')
									//{
										//SetFontAndColor(q+1,q+1,&f,B_FONT_ALL,&prefs->fg_color);
									//}
									//else if(q == eol)
									//{
										//SetFontAndColor(eol+1,eol+1,&f,B_FONT_ALL,&prefs->fg_color);
									//}		
								}		
							//}	
							*/	


