#include "TexView.h"


#include <StopWatch.h>
#include <storage/File.h>

TexView::TexView(BRect r,BRect textRect,Prefs* p) : 
BTextView(r,"texview",textRect,B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_PULSE_NEEDED/*|B_NAVIGABLE*/)
{
	//if(p == NULL)
	//BStopWatch* construct = new BStopWatch("Construct Timer");
	prefs = p;
	IsColSel = false;
	BFont fontie(be_fixed_font);
	f = fontie;
	f.SetSize(prefs->FontSize);
	SetFontAndColor(0,1,&f,B_FONT_ALL,&prefs->fg_color);
	SetStylable(prefs->IsSyntax);
	SetAlignment(B_ALIGN_LEFT);
	//SetDoesUndo(true);
	SetAutoindent(prefs->AutoIndent);
	//IsUndo = false;
	
	IsNormalFocus = false;
	HasAttachedFocus = false;
	//TextStyles
	green_matches.push_back("textbf");
	green_matches.push_back("textit");
	green_matches.push_back("textmd");
	green_matches.push_back("textrm");
	green_matches.push_back("textsc");
	green_matches.push_back("textsf");
	green_matches.push_back("textsl");
	green_matches.push_back("texttt");
	green_matches.push_back("textup");
	green_matches.push_back("emph");

	green_matches.push_back("bf");
	green_matches.push_back("it");
	green_matches.push_back("em");
	green_matches.push_back("rm");
	green_matches.push_back("sc");
	green_matches.push_back("sf");
	green_matches.push_back("sl");
	green_matches.push_back("tt");
	green_matches.push_back("up");

	//green_matches.push_back("begin");
	//green_matches.push_back("end");

	//TextSizes
	green_matches.push_back("tiny");
	green_matches.push_back("scriptsize");
	green_matches.push_back("footnotesize");
	green_matches.push_back("small");
	green_matches.push_back("normalsize");
	green_matches.push_back("large");
	green_matches.push_back("Large");
	green_matches.push_back("LARGE");
	green_matches.push_back("huge");
	green_matches.push_back("Huge");

    green_matches.push_back("mathbb");
    green_matches.push_back("mathbf");
    green_matches.push_back("mathcal");
    green_matches.push_back("mathfrak");
    green_matches.push_back("mathit");
    green_matches.push_back("mathnormal");
    green_matches.push_back("mathrm");
    green_matches.push_back("mathsf");
    green_matches.push_back("mathtt");

    green_matches.push_back("rmfamily");
    green_matches.push_back("sffamily");
    green_matches.push_back("ttfamily");

    green_matches.push_back("itshape");
    green_matches.push_back("scshape");
    green_matches.push_back("slshape");
    green_matches.push_back("upshape");

    green_matches.push_back("bfseries");
    green_matches.push_back("mdseries");
 	
	purple_matches.push_back("author");
	purple_matches.push_back("title");
	purple_matches.push_back("section");
	purple_matches.push_back("subsection");
	purple_matches.push_back("subsubsection");
	purple_matches.push_back("subsubsubsection");
	purple_matches.push_back("verb");
/*	double construct_time = double(construct->ElapsedTime())/1000000;
	delete construct;
*/	
	// putting this in attachedtowindow would be not a good idea.
	BEntry entry("file.tex");
	if(entry.InitCheck() == B_OK)
	{
		entry_ref ref;
		entry.GetRef(&ref);
		LoadFile(&ref);
	}

}

void TexView::FrameResized(float w,float h)
{
	//nice resizable text
	if(w > 250 && h > 250)
	{
		BRect r = BRect(0,0,w,h);
		r.InsetBy(5,5);
		SetTextRect(r);
	}
}
bool TexView::IsBrace(char c)
{
	switch(c) {
		case '{':
		case '[':
		case '}':
		case ']':
			return true;
	}
	
	return false;
}
void TexView::AttachedToWindow()
{
	SetViewColor(prefs->bg_color);
	SetColorSpace(B_RGB32);
	BTextView::AttachedToWindow();
	if(HasAttachedFocus)
	{
		MakeFocus(true);
	}

}
void TexView::Select(int32 start,int32 finish)
{

	BTextView::Select(start,finish);
	BMessenger msgr(Window());
	msgr.SendMessage(new BMessage(UPDATE_STATUSBAR));
}
void TexView::SetNormalFocus()
{
	IsNormalFocus = true;
	
}
void TexView::SetAttachedFocus()
{
	HasAttachedFocus = true;
}
void TexView::MouseUp(BPoint point)
{
	//IsColSel = false;
	BTextView::MouseUp(point);
}
void TexView::Draw(BRect r)
{
	BTextView::Draw(r);
/*	if(IsColSel)
	{
		
		BRect ColumnRect(ColStart,ColFinish);
		//SetHighColor(0,255,0,128);
		//SetDrawingMode(B_OP_ALPHA);
		InvertRect(ColumnRect);
	}
*/
}
void TexView::MouseMoved(BPoint point,uint32 transit,const BMessage* msg)
{
	if(!IsNormalFocus)
	{
		switch(transit)
		{
			case B_ENTERED_VIEW:
			{
				MakeFocus(true);
			}break;
			case B_EXITED_VIEW:
			{
				MakeFocus(false);
			}break;
		}
	}
	
	int32 offset = OffsetAt(point);
	BString theUrl = FindUrl(offset);
	bool IsValidUrl = theUrl.Length() > 0;
	#ifdef B_BEOS_VERSION_5
    	SetViewCursor(IsValidUrl ? B_CURSOR_SYSTEM_DEFAULT : B_CURSOR_I_BEAM);
	#else
   	   	be_app->SetCursor(IsValidUrl ? B_HAND_CURSOR : B_I_BEAM_CURSOR);
	#endif
	//if(IsValidUrl)
	//{
		
		//char* url = (char*)theUrl.String();
		//be_roster->Launch("text/html",1,&url);
	//}

/*	if(IsColSel)
	{
		ColFinish = point;
		float height = LineHeight();
		
		//BPoint ColTopRight(ColFinish.x,ColStart.y);
		//BPoint ColBtmLeft(ColStart.x,ColFinish.y);
		//Invalidate();
		//if(ColFinish != point)
		//{
		ParseAll(OffsetAt(ColStart),OffsetAt(ColFinish));
		for(float i=ColStart.y;i<=ColFinish.y;i+=height)
		{
			int32 start,finish;
			start = OffsetAt(BPoint(ColStart.x,i));
			finish = OffsetAt(BPoint(ColFinish.x,i));
			//Highlight(start,finish);
			rgb_color y_col = {255,255,0};
			
			SetFontAndColor(start,finish,&f,B_FONT_ALL,&y_col);
		}
		//}
	
	}
	else*/
		BTextView::MouseMoved(point,transit,msg);
}
bool TexView::IsBadUrlChar(int32 h)
{
	if(IsBrace(ByteAt(h)))
		return true;
	if(ByteAt(h) == ' ' || ByteAt(h) == '(' || ByteAt(h) == ')' || ByteAt(h) == '|'
	|| ByteAt(h) == '\\'|| ByteAt(h) == '\n')
		return true;
	return false;
}
bool TexView::IsUrlCommented(int32 start,int32 finish)
{
	text_run_array* tra = RunArray(start,finish);
	if(tra == NULL)
		return false;
	return (tra->count == 1 && tra->runs[0].color == prefs->comment_color);
}
BString TexView::FindUrl(int32 offset)
{
	BString url="";
	if(IsBadUrlChar(offset))
		return url;
	int text_length = TextLength();
	vector<int> sols;
	vector<int> eols;
	FillSolEol(sols,eols,offset,offset+1);
	
	if(sols.size() != eols.size())
		return url;
	int sol = sols[0];
	int eol = eols[0];
	
	
	int i;
	int start=-1;
	//try looking left
	bool DoneSearch=false;
	for(i=offset;i>=sol;i--)
	{
		if(IsBadUrlChar(i))
		{
			start = i+1;
			DoneSearch = true;
			break;
		}
	}	
	if(DoneSearch == false)
		start = sol;
				
	DoneSearch=false;	
	int finish = -1;
	for(i=offset;i<eol;i++)
	{
		if(IsBadUrlChar(i))
		{
			finish = i-1;
			DoneSearch = true;
			break;
		}
	}	
	if(DoneSearch == false)
		finish = eol-1;
	
	
	if(start < 0 || finish < 0 || IsUrlCommented(start,finish))
		return url;
	
	if(start +1 < text_length &&
	start +2 < text_length &&
	start +3 < text_length &&
	start +4 < text_length &&
	start +5 < text_length &&
	start +6 < text_length &&
	ByteAt(start) == 'h' &&
	ByteAt(start+1) == 't' &&
	ByteAt(start+2) == 't' &&
	ByteAt(start+3) == 'p' &&
	ByteAt(start+4) == ':' &&
	ByteAt(start+5) == '/' &&
	ByteAt(start+6) == '/')
	{
		for(i=start;i<=finish;i++)
		{
			//if(i==finish)
				url <<(char)ByteAt(i);//= strcat(url,(const char*)ByteAt(i));
			//else
			//	strcat(url,(const char*)ByteAt(i));
		}	
	}
	return url;
	
//	return NULL;
	//try looking right
	


}
void TexView::MouseDown(BPoint point)
{
	int32 offset = OffsetAt(point);
	BString theUrl = FindUrl(offset);
	if(theUrl.Length() > 0)
	{
		char* url = (char*)theUrl.String();
		be_roster->Launch("text/html",1,&url);
	}
	/*if(modifiers() & B_CONTROL_KEY)
	{
		IsColSel = true;
		ColStart = point;
	
	
	}
	else*/
		BTextView::MouseDown(point);
}
void TexView::KeyDown(const char* bytes, int32 numBytes)
{
	switch(bytes[0])
	{
		case B_ENTER:
		{
			//update previous line on enter
			BMessage msg(PARSE_LINE);
			int32 start,finish;
			GetSelection(&start,&finish);
			if(msg.AddInt32("start",start) == B_OK
			&& msg.AddInt32("finish",finish) == B_OK)
			Window()->PostMessage(&msg,this);
		}break;
		
		case B_TAB:
		{
			if(IsNormalFocus)
			{
				Parent()->NextSibling()->MakeFocus();
				return;
			}
		} break;
	}
		
		
	BTextView::KeyDown(bytes,numBytes);
	BMessenger msgr(Window());
	msgr.SendMessage(new BMessage(UPDATE_STATUSBAR));
}

int TexView::FindFirstOnLine(char c,int offset,int eol)
{
	for(int i=offset;i<eol;i++)
	{
		if(ByteAt(i) == c)
			return i;
	}
	return -1;
}

int32 TexView::OffsetAt(int32 index) //const
{
	vector<int> sols;
	vector<int> eols;
	FillSolEol(sols,eols,index,index+1);
	for(int i=0;i<sols.size();i++)
	{
		if(index >= sols[i] && index <= eols[i])
			return sols[i];
	}
	return -1;	
}
int32 TexView::OffsetAt(BPoint point)
{
	return BTextView::OffsetAt(point);
}

int32 TexView::LineAt(int32 offset) //const
{
	vector<int> sols;
	vector<int> eols;
	FillSolEol(sols,eols,0,TextLength()-1);

	for(int i=0;i<sols.size();i++)
	{
		if(offset >= sols[i] && offset <= eols[i])
			return i;
	}
	return -1;
}
void TexView::FillSolEol(vector<int>& s,vector<int>& e,int start,int finish)
{
	int i;
	int text_length = TextLength();
	int sof;
	int eof;
	for(i=start;i>=0;i--)
	{
		if(ByteAt(i) == '\n')
		{
			break;
		}
	}
	sof=i+1;
	
	for(i=finish;i<text_length;i++)
	{
		if(ByteAt(i) == '\n')
		{
			
			break;
		}
	}
	eof=i;
	s.push_back(sof);
	for(int i=start+1;i<finish;i++)
	{
		if(ByteAt(i) == '\n')
		{
			e.push_back(i);
			s.push_back(i+1);
			
		}
	}
	e.push_back(eof);		

}
void TexView::GoToLine(int32 index)
{
	if(index < 0 || index > CountLines() || TextLength() <= 0)
		return;
		
	vector<int> eols;
	vector<int> sols;
	
	FillSolEol(sols,eols,0,TextLength()-1);
	Select(sols[index],eols[index]);
}
int32 TexView::CountLines()
{
	vector<int> eols;
	vector<int> sols;
	FillSolEol(sols,eols,0,TextLength()-1);	
	return eols.size();
}
void TexView::ParseAll(int start,int finish,bool IsInteractive)
{
	//start=0;
	//finish=TextLength()-1;
	BFont font(be_fixed_font);
	font.SetSize(prefs->FontSize);
	
	int text_length = TextLength();
	if(text_length > 0)
	{
		//BStopWatch* init = new BStopWatch("Init Timer");
		vector<int> eols;
		vector<int> sols;
		FillSolEol(sols,eols,start,finish);
		
		int i;
		int start_idx=sols[0];
		int finish_idx=eols[eols.size()-1];
		/*
		for(i=0;i<sols.size();i++)
		{
			if(start <= eols[i] && start >= sols[i])
				start_idx = i;
			if(finish <= eols[i] && finish >= sols[i])
				finish_idx = i;
			if(start_idx >= 0 && finish_idx >=0)
				break;
		}
		*/
		int displaced = sols[0];
		int size = finish_idx - start_idx+1;//eols[finish_idx]- sols[start_idx]+1;
		
		vector<rgb_color> colorVec(size,prefs->fg_color);//);
		//double init_time = double(init->ElapsedTime())/1000000;
		//delete init;
		
//		BStopWatch* loopy = new BStopWatch("Loopy Timer");
		//SetMathModes(colorVec);
		
		for(i=0;i<sols.size();i++)//i=start_idx;i<=finish_idx;i++)
		{
			//HandleDeletion(NULL,sols[i],eols[i]);
			//SetFontAndColor(sols[i],eols[i],&font,B_FONT_ALL,&prefs->fg_color);
			ParseLine(sols[i],eols[i],colorVec,displaced);		
		}

/*		double loopy_time = double(loopy->ElapsedTime())/1000000;
		delete loopy;
*/
	

		if(!IsInteractive)
		{
			int size=1;
			vector<int> offsets;
			offsets.push_back(0);
			
			for(i=1;i<colorVec.size();i++)
			{
				if(colorVec[i-1-displaced] != colorVec[i-displaced])
				{
					offsets.push_back(i);	
					size++;
				}
			}
			text_run_array* tra = (text_run_array*)malloc(sizeof(text_run_array)*(size));//new text_run_array;
			tra->count = size;
			for(i=0;i<size;i++)
			{
				tra->runs[i].color=colorVec[offsets[i]-displaced];
				tra->runs[i].font=font;
				tra->runs[i].offset=offsets[i];
			}
//			BStopWatch* watch = new BStopWatch("RunArray Timer");
			SetRunArray(0,TextLength()-1,tra);
/*			double time = double(watch->ElapsedTime())/1000000;
			delete watch;
*/
		}
		else
		{
			vector<rgb_color> oldColor;//(size);
			//vector<BFont> oldFont;
			BFont tmp_font;
			rgb_color color;
			//eols[finish_idx]-sols[start_idx]+1;
			//BStopWatch* watch = new BStopWatch("GetArray Timer");
			for(i=start_idx;i<=finish_idx;i++)
			{
				GetFontAndColor(i,&tmp_font,&color);
				//oldColor[i] = color;
				oldColor.push_back(color);
			}	
			//double time = double(watch->ElapsedTime())/1000000;
			//delete watch;
			
			//int last = displaced;
			//int length=1;
			
/*			for(i=0;i<colorVec.size();i++)
			{
					SetFontAndColor(i+displaced,i+displaced+1,&font,B_FONT_ALL,&colorVec[i]);
			}
*/

		int plLength=1;
		int plStart=displaced;
		for(i=displaced+1;i<=finish_idx;i++)
		{
			
			if(colorVec[i-displaced] != colorVec[i-displaced-1])
			{
				if(colorVec[i-displaced-1] != oldColor[i-displaced-1])
					SetFontAndColor(plStart,plStart+plLength,&font,B_FONT_ALL,&colorVec[i-displaced-1]);		
				
				plLength = 1;
				plStart = i;
			}
			else
			{
				plLength++;
			}	
		}
		
		if(plLength > 0)
			SetFontAndColor(plStart,plStart+plLength,&font,B_FONT_ALL,&colorVec[i-displaced-1]);		
	
	
	
	
		}
	
	}
}
void TexView::ParseLine(int sol,int eol,vector<rgb_color>& colorVec,int displaced)
{
		int i;
		int offset = sol;
		int pos;

		BFont default_font(be_fixed_font);
		default_font.SetSize(prefs->FontSize);
		//vector<BFont> fontVec(eol-sol+1,default_font);
		//Setup some defaults....
		TwoColorPlateau('\'',sol,eol,prefs->comma_color,prefs->fg_color,colorVec,displaced);//-displaced
		TwoColorPlateau('`',sol,eol,prefs->comma_color,prefs->fg_color,colorVec,displaced);
		TwoColorPlateau('\\',sol,eol,prefs->punc_symbol_color,prefs->fg_color,colorVec,displaced);
		for(i=sol;i<eol;i++)
		{
			if(ByteAt(i) == '[' || ByteAt(i) == ']')
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1-displaced] = prefs->punc_symbol_color;
				}
					
				colorVec[i-displaced] = prefs->punc_symbol_color;			
				
			}
			else if(ByteAt(i) == '&' || ByteAt(i) == '{' || ByteAt(i) == '}')//
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1-displaced] = prefs->punc_symbol_color;
				}
					
				colorVec[i-displaced] = prefs->punc_symbol_color;			
				
			}
			else if(ByteAt(i) == '$')
			{
				if(i-1 >= 0 && ByteAt(i-1) == '\\')
				{
					colorVec[i-1-displaced] = prefs->fg_color;
					colorVec[i-displaced] = prefs->fg_color;
				}
			}
			else if(ByteAt(i) == '\\' && i+1 < eol)
			{
				if(ByteAt(i+1) == '#')
				{	
					colorVec[i-displaced] = prefs->punc_symbol_color;
					colorVec[i+1-displaced] = prefs->punc_symbol_color;
				}else if(ByteAt(i+1) == '\'' || ByteAt(i+1) == '`')
				{
					colorVec[i-displaced] = prefs->fg_color;
					colorVec[i+1-displaced] = prefs->fg_color;
				}
			}
			
			else if(ByteAt(i) == 'h')
			{
				if(i+1 < eol && ByteAt(i+1) == 't' && i+2 < eol && ByteAt(i+2) == 't' && i+3 < eol && ByteAt(i+3) == 'p'
				&& i+4 < eol && ByteAt(i+4) == ':' && i+5 < eol && ByteAt(i+5) == '/' && i+6 < eol && ByteAt(i+6) == '/')
				{
					int h=i;
					while(h < eol && !IsBadUrlChar(h))// != ' ')
					{
						colorVec[h-displaced] = prefs->html_color;
						h++;
					}		
				}
			}
		}

		offset = sol;
		int url_pos;
		int url_last;
		url_pos = FindFirstUrlOnLine(offset,eol);
		url_last = FindLastUrlPos(url_pos,eol);
		
		while((pos = FindFirstOnLine('%',offset,eol))>= 0 && offset < eol)
		{
			
			if(pos > url_last)
			{
				url_pos = FindFirstUrlOnLine(url_last,eol);

				url_last = FindLastUrlPos(url_pos,eol);
			}
			if(pos < url_pos || pos > url_last)
			{
				if(pos - 1 >= 0 && ByteAt(pos-1) == '\\')
				{
						colorVec[pos-1-displaced] = prefs->punc_symbol_color;
						colorVec[pos-displaced] = prefs->punc_symbol_color;
				}
				else 
				{
					for(i=pos;i<eol;i++)
						colorVec[i-displaced] = prefs->comment_color;
					break;
				}
			}
			offset= pos+1;
		}	

}
int TexView::FindLastUrlPos(int h,int eol)
{
	if(h < 0)
		return -1;
	for(int i=h;i<eol;i++)
	{
		if(IsBadUrlChar(i))
			return i-1;
	}
	return eol;
}
int TexView::FindFirstUrlOnLine(int offset,int eol)
{
	int h=-1;
	bool IsUrl=false;
	
	while(h < eol && !IsUrl)
	{
		h = FindFirstOnLine('h',offset,eol);
		if(h < 0)
			return -1;
		IsUrl=(h+1 < eol &&
		h+2 < eol &&
		h+3 < eol &&
		h+4 < eol &&
		h+5 < eol &&
		h+6 < eol &&
		ByteAt(h+1) == 't' &&
		ByteAt(h+2) == 't' &&
		ByteAt(h+3) == 'p' &&
		ByteAt(h+4) == ':' &&
		ByteAt(h+5) == '/' &&
		ByteAt(h+6) == '/');	
		if(IsUrl)
			return h;
			
		offset = h+1;
	}
	return h;	
}
void TexView::TwoColorPlateau(char c,int sol,int eol,
rgb_color c1,rgb_color c2,vector<rgb_color>& colorVec,int displaced)
{
		int IsPlateau = false;
		int plLength = 0;
		int plStart;
		int i;
		for(i=sol;i<=eol;i++)
		{
			//start a plateau
			if(c == '\\' && !IsPlateau && ByteAt(i) == c)
			{
				plStart = i;
				plLength++;
				IsPlateau = true;
			}
			else if(c != '\\' && !IsPlateau && ByteAt(i) == c &&  i - 1 >= 0 && ByteAt(i-1) != '\\')
			{
				plStart = i;
				plLength++;
				IsPlateau = true;
			}
			else if(IsPlateau && ByteAt(i) == c && i - 1 >= 0 && ByteAt(i-1) == c)
			{
				plLength++; 			
			}
			else if(IsPlateau && ByteAt(i) != c && i - 1 >= 0 && ByteAt(i-1) == c)
			{
				if(plLength % 2 == 0)
				{	
						for(int k=plStart;k<plStart+plLength;k++)
						{	
							if(k-displaced >= 0 && k-displaced < colorVec.size())
							colorVec[k-displaced] = c1;
						}
				}
				else
				{
						
					for(int k=plStart;k<plStart+plLength-1 && k < eol;k++)
					{
						if(k-displaced >= 0 && k-displaced < colorVec.size())
							colorVec[k-displaced] = c1;
					}
					if(c == '\\' && isalpha(ByteAt(i)))
					{
						BString match;
						match << (char)ByteAt(i);
						
						int j;
						for(j=i+1;j < eol;j++)
						{
							if(isalpha(ByteAt(j)))
								match << (char)ByteAt(j);
							else
								break;
						}
									
						if(Contains(green_matches,match))
						{
								for(int k=i-1;k<j;k++)
									colorVec[k-displaced] = prefs->format_cmd_color;
						}
						else if(Contains(purple_matches,match))
						{
								for(int k=i-1;k<j;k++)
									colorVec[k-displaced] = prefs->special_cmd_color;
						}
						else
						{
								for(int k=i-1;k<j;k++)
								{
									colorVec[k-displaced] = prefs->generic_cmd_color;
								}
						}
					}	
					else
					{
							if(plStart+plLength-1-displaced >= 0 && plStart+plLength-1-displaced<colorVec.size())
							colorVec[plStart+plLength-1-displaced] = c2;
							if(plStart+plLength-displaced >= 0 && plStart+plLength-displaced <colorVec.size())
							colorVec[plStart+plLength-displaced] = c2;
					}
					
				}

				IsPlateau = false;
				plLength = 0;
			}
		}
		if(IsPlateau)
		{
				if(plLength % 2 == 0)
				{	
						for(int k=plStart;k<plStart+plLength;k++)
						{	
							if(k-displaced >= 0 && k-displaced < colorVec.size())
							colorVec[k-displaced] = c1;
						}
					
				}else
				{
						for(int k=plStart;k<plStart+plLength-1 && k < eol;k++)
						{
						if(k-displaced >= 0 && k-displaced < colorVec.size())
							colorVec[k-displaced] = c1;
						}
					
					if(c == '\\' && isalpha(ByteAt(i)))
					{
						BString match;
						match << (char)ByteAt(i);
						int j;
						for(j=i+1;j < eol;j++)
						{
							if(isalpha(ByteAt(j)))
								match += ByteAt(j);
							else
								break;
						}					
						if(Contains(green_matches,match))
						{
								for(int k=i-1;k<j;k++)
									colorVec[k-displaced] = prefs->format_cmd_color;								

						}
						else if(Contains(purple_matches,match))
						{
								for(int k=i-1;k<j;k++)
									colorVec[k-displaced] = prefs->special_cmd_color;
						}
						else
						{
								for(int k=i-1;k<j;k++)
								{	
									colorVec[k-displaced] = prefs->generic_cmd_color;
								}	
						}
					}	
					else
					{
							if(plStart+plLength-1-displaced >= 0 && plStart+plLength-1-displaced<colorVec.size())
							colorVec[plStart+plLength-1-displaced] = c2;
							if(plStart+plLength-displaced >= 0 && plStart+plLength-displaced<colorVec.size())
							colorVec[plStart+plLength-displaced] = c2;						
					}
				}

				IsPlateau = false;
				plLength = 0;
		}

}
int TexView::IsMathMode(int offset/*,int sol,int eol*/,vector<BString>& v,bool IsStart/*,bool& IsMultiLine*/)
{
	for(int i=0;i<v.size();i++)
	{
		//try all possibilities....
		if(/*offset < eol &&*/ByteAt(offset) == v[i].ByteAt(0))
		{
			//should be fixed to incorporate sol -- maybe not!
			if(offset-1 >= 0/*!= sol*/ && ByteAt(offset-1) == '\\')
				return -1;
				
			int len = v[i].Length();
			
//			else
//			{
				bool IsOk=true;
				int j=1;
				while(IsOk && j < len)
				{
					IsOk = (ByteAt(offset+j) == v[i].ByteAt(j));
					j++;
				}
				if(IsOk == true)
				{
					//IsMultiLine = true;//(i >=2);
					if(len > 2)
					{
						if(IsStart)
						return offset+j;
							else
						return offset;
					}
					else
					{
						if(IsStart)
							return offset;
						else
							return offset+j;
					}
					
				}
//			}		
		}
	}
	return -1;
}
void TexView::SetMathModes(vector<rgb_color>& colorVec)//,vector<BFont>& fontVec)
{
	vector<BString> start;
	vector<BString> end;
/*
		\begin{equation}
		\end{equation}
		\begin{displaymath}
		\end{displaymath}
		\begin{math}
		\end{math}
		\begin{eqnarray}
		\end{eqnarray}
		\begin{eqnarray*}
		\end{eqnarray*}
*/	
	start.push_back("$");
	start.push_back("\\[");
	start.push_back("\\begin{eqnarray*}");
	start.push_back("\\begin{eqnarray}");
	start.push_back("\\begin{equation}");
	start.push_back("\\begin{displaymath}");
	start.push_back("\\begin{math}");
	start.push_back("\\begin{verbatim}");
	
	end.push_back("$");
	end.push_back("\\]");
	end.push_back("\\end{eqnarray*}");
	end.push_back("\\end{eqnarray}");
	end.push_back("\\end{equation}");
	end.push_back("\\end{displaymath}");
	end.push_back("\\end{math}");
	end.push_back("\\end{verbatim}");
	
	int i;
	int32 spos;
	int32 fpos=-1;
	//bool IsMultiLine;
	int length=TextLength();
	
	for(i=0;i<length;i++)
	{
		if((spos = IsMathMode(i/*,sol,eol*/,start,true/*,IsMultiLine*/)) >= 0)
		{
			int k=spos+1;
			//int limit=TextLength();
			/*if(IsMultiLine)
			{
				limit=TextLength();
			}*/
			for(k=spos+1;k<length;k++)
			{
				if((fpos = IsMathMode(k,/*sol,eol,*/end,false/*,IsMultiLine*/)) >= 0)
					break;	
			}
			if(fpos == -1)
				fpos=length;
			
			for(int p=spos;p<fpos;p++)
			{
				colorVec[p] = prefs->math_mode_color;
			}
			i = k;
		}
	}
}

void TexView::InsertText(const char* text,int32 length,int32 offset,const text_run_array* runner)
{
	
	BTextView::InsertText(text,length,offset,NULL);
	if(text[0] != B_ENTER)
	{
		BMessage msg(ANALYSE_TEXVIEW);
		if(msg.AddInt32("offset",offset)==B_OK
		&& msg.AddInt32("length",length)==B_OK)
		//&& msg.AddString("text",text) == B_OK)
		Window()->PostMessage(&msg,this);
		Window()->PostMessage(new BMessage(FILE_CONTENTS_CHANGED));
	}
	
}
void TexView::DeleteText(int32 start, int32 finish)
{
	BMessage msg(ANALYSE_TEXVIEW);
	//char buf[finish-start];
	//GetText(start,finish-start,buf);
	if(msg.AddInt32("start",start)==B_OK
	&& msg.AddInt32("finish",finish)==B_OK)
	//&& msg.AddString("text",buf) == B_OK)
	Window()->PostMessage(&msg,this);
	BTextView::DeleteText(start,finish);
	Window()->PostMessage(new BMessage(FILE_CONTENTS_CHANGED));	
}


void TexView::SetText(const char* text,int32 length,const text_run_array* runs = NULL)
{
	BTextView::SetText(text,length,runs);
	ParseAll(0,length-1,false);
}
void TexView::UpdateColors()
{
	SetFontAndColor(0,TextLength(),&f,B_FONT_ALL,&prefs->fg_color);
	ParseAll(0,TextLength()-1,false);	
	//const char* text = Text();
	//Delete(0,TextLength()-1);
	//SetText(text,strlen(text));//,TextLength()-1);
}
void TexView::UpdateFontSize()
{
	f.SetSize(prefs->FontSize);
	SetFontAndColor(0,TextLength(),&f,B_FONT_ALL,&prefs->fg_color);
	ParseAll(0,TextLength()-1,false);	
}

void TexView::SetText(BFile* file,int32 offset,int32 length,const text_run_array* runs = NULL)
{
	BTextView::SetText(file,offset,length,runs);
	ParseAll(offset,length-1,false);
}
bool TexView::Contains(vector<BString>& v,BString s)
{
	for(int i=0;i<v.size();i++)
	{
		if(v[i] == s)
			return true;
	}
	return false;
}
bool TexView::CanEndLine(int32 offset)
{
	if(ByteAt(offset) == B_ENTER)
		return true;
	else
		return false;
}
int32 TexView::GetMathSol(int sol)
{
	/*bool IsMultiLine;
	vector<BString> start;
	start.push_back("$");
	start.push_back("\\[");
	start.push_back("\\begin{eqnarray*}");
	start.push_back("\\begin{eqnarray}");
	start.push_back("\\begin{equation}");
	start.push_back("\\begin{displaymath}");
	start.push_back("\\begin{math}");
	const char* text;
	int32 text_length = TextLength();
	int retval=-1;
	for(int i=sol;i>=0;i--)
	{
		if(retval = (IsMathMode(i,i,0,start,true,IsMultiLine) > 0))
			return retval;
	}
	return retval;
	*/
	return sol;
}
void TexView::MessageReceived(BMessage* msg)
{
	switch(msg->what)
	{
		case UNDO_HIGHLIGHTING:
		{
			int32 start,finish;
			if(msg->FindInt32("start",&start)==B_OK
			&& msg->FindInt32("finish",&finish)==B_OK
			)
			{			
				Select(start,finish);
			}
		}break;
		
		case PARSE_LINE:
		{
			int32 start,finish;
			if(msg->FindInt32("start",&start)==B_OK
			&& msg->FindInt32("finish",&finish)==B_OK
			)
			{	
				int32 sel_start,sel_finish;
				GetSelection(&sel_start,&sel_finish);
				ParseAll(min(sel_start,start),max(sel_finish,finish),true);
		}	
		}break;
		case ANALYSE_TEXVIEW:
		{		
			int32 start,finish;
			if(msg->FindInt32("start",&start)==B_OK
			&& msg->FindInt32("finish",&finish)==B_OK)
			{			
				ParseAll(start,finish,true);
			}
			
			int32 offset,length;
			if(msg->FindInt32("offset",&offset)==B_OK
			&& msg->FindInt32("length",&length)==B_OK)
			{
				GetSelection(&start,&finish);
				ParseAll(offset,finish,true);			
			}

		}break;
		
		case B_CUT:
		case B_COPY:
		case B_PASTE:
		{
			BMessage msg(UPDATE_CLIPBOARD_MENU_STATUS);
			Window()->PostMessage(&msg,this);
		}
		default:
			BTextView::MessageReceived(msg);
			
	}
}
void TexView::SetFontAndColor(int32 start,int32 finish,const BFont* font,uint32 properties=B_FONT_ALL,const rgb_color* color=NULL)
{
		BTextView::SetFontAndColor(start,finish,font,properties,color);
}

void TexView::LoadFile (entry_ref *ref)
{
	if (ref == NULL) {
		return;
	}
	
	BFile file(ref, B_READ_ONLY);
	if (file.InitCheck() != B_OK) {
		return;
	}
	
	off_t length;
	file.GetSize(&length);
	if (length == 0) {
		return;
	}
	
	SetText (&file, 0, length);
}
							//if(match == "textbf" || match == "textit"|| match == "bf"|| match == "it"
							//|| match == "emph" || match == "em" || match == "textsl" || match == "sl")
							//{
						/*		if(j < eol && text[j] == '{')
								{
									int numleft=1;
									int numright=0;
									int start=j+1;
									int q;
									for(q=j+1;q<eol;q++)
									{
										if(text[q] == '}')
										{
											numright++;
											//break;
										}
										else if(text[q] == '{')
										{
											numleft++;
											//break;
										}
										if(numleft == numright)
											break;
									}
								
									if(match == "textbf" || match == "bf")
										f.SetFace(B_BOLD_FACE);
									else if(match == "textit" || match == "it")
										f.SetFace(B_ITALIC_FACE);
									else if(match == "emph" || match == "em")
										f.SetFace(B_BOLD_FACE | B_ITALIC_FACE);
									else if(match == "textsl" || match == "sl")
										f.SetShear(120);
										
									//SetFontAndColor(start,q,&f,B_FONT_ALL,&prefs->fg_color);	
									//if(IsRecording)
									//{
										for(int k=start;k<q;k++)
										{	
											colorVec[k-sol] = prefs->fg_color;
											fontVec[k-sol] = f;
										}	
									//}
									
									f.SetFace(B_REGULAR_FACE);
									f.SetShear(90);
									
									
									//if(q < eol && text[q] == '}')
									//{
										//SetFontAndColor(q+1,q+1,&f,B_FONT_ALL,&prefs->fg_color);
									//}
									//else if(q == eol)
									//{
										//SetFontAndColor(eol+1,eol+1,&f,B_FONT_ALL,&prefs->fg_color);
									//}		
								}		
							//}	
							*/	


