#include <Application.h>
#include <Bitmap.h>
#include <TranslationUtils.h>
#include <iostream>
#include <Entry.h>
#include <File.h>
#include <stdio.h>
#include <fstream>
#include <string>
#include <Window.h>
#include <View.h>

void ChurnBitmap(BBitmap* bitmap)
{	//B G R A
	
	unsigned char* p = (unsigned char*)bitmap->Bits();
	int size = bitmap->BitsLength();
	
	for(int i=0;i<size;i+=4)
	{	
		p[i+3] = (unsigned char)255;
		
		if((int)p[i] == 255 && (int)p[i+1] == 0 && (int)p[i+2] == 255)
		{	
			p[i+3] = (unsigned char)0;
		
		}
		//cout << "RED = " << (int)p[i+2] << ", GREEN = " << (int)p[i+1] << ", BLUE = " << (int)p[i] << ", ALPHA = "<< (int)p[i+3] << endl;
	}
}
void TintBitmap(BBitmap* bitmap,const float tint)
{
	unsigned char* p = (unsigned char*)bitmap->Bits();
	rgb_color temp;
	for(int i=0;i<bitmap->BitsLength();i+=4)
	{
		//B G R A
		temp.blue = (uint8)p[i];
		temp.green = (uint8)p[i+1];
		temp.red = (uint8)p[i+2];
		//temp.alpha = (uint8)p[i+3];
		
		temp = tint_color(temp,tint);
		
		p[i] = (unsigned char)temp.blue;
		p[i+1] = (unsigned char)temp.green;
		p[i+2] = (unsigned char)temp.red;
		//p[i+3] = (unsigned char)temp.alpha;
	}
}

int main(int argc,char* argv[])
{
	if(argc < 4)
	{
		cout << "Usage: ./image2array <image> <array.h> [array name]" << endl;
		return 1;
	}
	BEntry entry(argv[1]);
	entry_ref ref;
	if(entry.GetRef(&ref) == B_OK)
	{
		BApplication app("application/x-vnd.misza-prep_image");

		BBitmap* bitmap;
		
		bitmap = BTranslationUtils::GetBitmap(&ref);
		if(bitmap != NULL)
		{
			ofstream outfile(argv[2]);
			BRect r = bitmap->Bounds();
			//ChurnBitmap(bitmap);
			unsigned char* p = (unsigned char*)bitmap->Bits();
			int size = bitmap->BitsLength();
			outfile << "//width = " << bitmap->Bounds().Width() << " , height = " << bitmap->Bounds().Height() << endl;
			outfile << "const unsigned char " << argv[3] << "[] = {\n";
			int count = 0;
	
			char buf[10];
			for(int i=0;i<size;i+=4)
			{
				if(i+3 == size -1)
				{	
					sprintf(buf,"%u,%u,%u};",p[i+2],p[i+1],p[i]);
					outfile << buf;
				}
				else
				{
					sprintf(buf,"%u,%u,%u,",p[i+2],p[i+1],p[i]);
					outfile << buf;				
				}	
				if(count == 18)
				{	
					outfile << endl;
					count = 0;	
				}
				else
					count+=3;
			}
			outfile << endl;
			outfile.close();
		}
	}
	return 0;			
		
}	

		
