#ifndef _MISZA_GRADIENT_VIEW_H_
#define _MISZA_GRADIENT_VIEW_H_

#include "misza_view.h"
#include <vector.h>
#include "misza_colours.h"
//#include "misza_enum.h"

//for zGradientView - used to specify gradient orientation
//#include "betex_logo_small.h"

enum misza_orientation {
Z_TOP_BTM=0,
Z_BTM_TOP,
Z_LFT_RHT,
Z_RHT_LFT,
Z_RBTM_TLFT,
Z_TLFT_RBTM,
Z_LBTM_TRHT,
Z_TRHT_LBTM,
Z_CEN_PYR,
Z_BOR_PYR
};

class zGradientView : public zView
{
	public:
		zGradientView(BRect frame,rgb_color top,rgb_color bottom,
					  misza_orientation ori=Z_TOP_BTM);
		virtual void AttachedToWindow();
		virtual void Draw(BRect drawRect);
		void Render();
		void SetOrientation(misza_orientation ori);
		void SetTop(rgb_color top);
		void SetBottom(rgb_color bottom);
		void SwitchColours();
		void Refill();
		void RestoreColours();
		void FillDiagonal(vector<rgb_color> &vert_vec,vector<rgb_color> &horiz_vec,bool switch_v,bool switch_h);
		void DrawDiagonal(BRect r,vector<rgb_color>& draw_vert,vector<rgb_color>& draw_horiz);
	private:
		rgb_color Ctop;
		rgb_color Cbottom;
		rgb_color Otop;
		rgb_color Obottom;
		vector<rgb_color> v;
		vector<rgb_color> v_horiz;
		vector<rgb_color> v_vert;
		
		vector<rgb_color> pvh_tl;
		vector<rgb_color> pvv_tl;

		vector<rgb_color> pvh_tr;
		vector<rgb_color> pvv_tr;

		vector<rgb_color> pvh_bl;
		vector<rgb_color> pvv_bl;

		vector<rgb_color> pvh_br;
		vector<rgb_color> pvv_br;
		
		misza_orientation theOri;
		//BBitmap* diagonal;
		//BBitmap* logo;
	
};
#endif //_MISZA_GRADIENT_VIEW_H_


